/*
 NSF.h

 * MacFCEU 0.9d3
 *
 * Copyright notice for this file:
 *  nsf.h Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* ---- typedefs */

typedef struct/*(136)*/
{
	char	ID[5]; /*NESM^Z*/
	uint8	Version;
/*06*/	uint8	TotalSongs;
	uint8	StartingSong;
/*08*/	uint8	LoadAddressLow;
	uint8	LoadAddressHigh;
/*0A*/	uint8	InitAddressLow;
	uint8	InitAddressHigh;
/*0C*/	uint8	PlayAddressLow;
	uint8	PlayAddressHigh;
/*0E*/	uint8	SongName[32];
/*2E*/	uint8	Artist[32];
/*4E*/	uint8	Copyright[32];
/*6E*/	uint8	NTSCspeed[2];
/*70*/	uint8	BankSwitch[8];
/*78*/	uint8	PALspeed[2];
/*7A*/	uint8	VideoSystem;
	uint8	SoundChip;
/*7C*/	uint8	Expansion[4];
	uint8	reserved[8];
} NSF_HEADER;

/* ---- globals */

extern int	NSFCycles;
extern int8	NSFMaxInitFrames;

/* ---- prototypes */

void NSF_init(void);
void DrawNSF(uint8 *XBuf);
void NSFDealloc(void);
void NSFDodo(void);
void DoNSFFrame(void);

/* these were previously prototyped exclusively */
void NSFGI(int h);
int NSFLoad(struct FCEUFILE *fp);
