;asm6502 -P0 -F$3800 {0} {"Parameters"};Exit 0
;
; NSFROM.asm
;

SCVRC6		equ	0
SCVRC7		equ	1
SCNFDS		equ	2
SCMMC5		equ	3
SCN106		equ	4
SCSFME		equ	5

NMIReset	equ	$20
NMISongReload	equ	$40
NMIEnabled	equ	$80

;write
EnableNMI	equ	$38FF

;read
InitAddr	equ	$38F8
PlayAddr	equ	$38FA
SoundChip	equ	$38FC
PAL		equ	$38FD
InitSong	equ	$38FE
NMIState	equ	$38FF ;clears SongReload, returns old

BANKSET		equ	$5FF0

	org	$3880

;	db	<rst

nmi	pha
	bit	NMIState
	bvs	isnd

	txa			; Save registers, and play.
	pha
	tya
	pha
	jsr	play		; JSR to play routine JMP.
	pla
	tay
	pla
	tax
	pla
	sta	EnableNMI
	rti

isnd	ldx	#$FF		; Initialize the stack pointer.
	txs
	inx			; X now #0
	txa
-	sta	$4000,X		; Sound init
	inx
	cpx	#$14
	bne	-

	sta	$4015
	lda	SoundChip	; Check FDS
	and	#1<<SCNFDS
	beq	nofds

	lda	#$80
	sta	$4089
	lda	#$E8
	sta	$408A
nofds	lda	#$0F		; Final audio init.
	sta	$4015
	lda	#$C0
	sta	$4017
	lda	InitSong	; This calls NSFReset.
	ldx	PAL
	jsr	init
	jsr	play		; JSR to play routine JMP.
	sta	EnableNMI
	clc
	bcc	*		; Loop.

init	jmp	(InitAddr)
play	lda	#0		; Zero out registers.
	tax
	tay
	jmp	(PlayAddr)	; Called by a JSR above.

  end
