/*
 PPUtile.h
  included by PPU.c

 * MacFCEU 0.8a6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef PPUT_MMC5SP
	uint8	xs = X1, ys = (scantileline+MMC5SplitY)&0x1F;

	if (ys>0x1D)
		ys-= 0x1E;
#endif
	if (X1>=2)
#ifdef env68k
 #define _ccsc 8
 #define _ccs5 <<8-6
		P = blittile(P,pshift0,pshift1,atlatch,XOffset);
#else
 #define _ccsc 2
 #define _ccs5 >>6-2
	{
		uint32	v;

		v = PPU_LUT1to4[pshift1>>xdownshift&0xFF], v+= v;
		v|= PPU_LUT1to4[pshift0>>xdownshift&0xFF];
		tilespr32(P,PPUPal,v|PPU_TileLUT[XOffset|(atlatch<<3)]);
		P+= 8;
	}
#endif
	{
		uint8	*C;
		register unsigned cc; /*uint8*/
		uint32	vadr;
	#ifdef PPUT_MMC5SP
		vadr = ((uint32)MMC5ExRAM[xs|((uint32)ys<<5)]<<4)+(vofs&7);
	#else
		register unsigned zz = RefreshAddr&0x1F;

		C = vnapage[RefreshAddr>>10&3];
		vadr = ((uint32)C[RefreshAddr&0x3FF]<<4)+vofs; //Fetch name table byte
	#endif

	#ifdef PPUT_HOOK
		PPU_hook(0x2000|(RefreshAddr&0xFFF));
	#endif

	#ifdef PPUT_MMC5SP
		cc = MMC5ExRAM[0x3C0+(xs>>2)+((ys+ys)&0x38)];
		cc = ((cc>>(xs&2)+(ys&2)*2)&3)<<_ccsc;
	#elif defined(PPUT_MMC5CHR1)
		cc = (uint32)(MMC5ExRAM[RefreshAddr&0x3FF]&0xC0)_ccs5;
	#else
		cc = C[0x3C0+(zz>>2)+((RefreshAddr&0x380)>>4)]; /*Fetch attr. table byte*/
		cc = (uint32)((cc>>(zz&2)+(RefreshAddr>>4&4))&3)<<_ccsc;
	#endif
		atlatch = atlatch>>_ccsc|cc;
	#ifdef PPUT_MMC5SP
		C = MMC5VROMPtr+vadr;
		C+= (uint32)(MMC5SplitBank&MMC5VROMMask)<<12;
	#elif defined(PPUT_MMC5CHR1)
		C = MMC5VROMPtr+(vadr&0xFFF);
		C+= (uint32)(MMC5ExRAM[RefreshAddr&0x3FF]&MMC5VROMMask)<<12;
		C+= (uint32)MMC5CHRHigh<<18; //FCEUX's 2009.06.11 update for kuja_killer
	#elif defined(PPUT_MMC5)
		C = MMC5BGVRAMADR(vadr);
	#else
		C = VRAMADR(vadr);
	#endif

	#ifdef PPUT_HOOK
		PPU_hook(vadr);
	#endif
		pshift0 = pshift0<<8|*C,
		pshift1 = pshift1<<8|C[8];
	}

	if (!(~RefreshAddr&0x1F))
		RefreshAddr^= 0x41F;
	else
		++RefreshAddr;

#ifdef PPUT_HOOK
	PPU_hook(0x2000|(RefreshAddr&0xFFF));
#endif
