/*
 boards/BMCBallGames.c

 * MacFCEU 0.6.4
 *
 * Copyright notice for this file:
 *  51.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "unlicensed.h"

/* ---- mapper 51: BMC BallGames 11-in-1 */

#define mode GameMemBlock[0]
#define page GameMemBlock[1]

static void Synco(void)
{
	uint32		o;

	if (mode&1)
	{
		setprg32(0x8000,page);
		o = 0x23;
	} else
	{
		o = page+page;
		setprg16(0x8000,o|(mode>>1));
		setprg16(0xC000,o|7);
		o = 0x2F;
	}
	setmirror(mode!=3);
}

static DECLFW(M51W6)
{
(void)A;
	mode = (V>>3&2)|(V&1);
	Synco();
}

static DECLFW(M51W8E)
{
(void)A;
	page = V&0xF;
	Synco();
}

static DECLFW(M51WC)
{
(void)A;
	page = V&0xF, mode = (V>>3&2)|(mode&1); /* prev. mode bit #0 reused */
	Synco();
}

static void M51Power(void)
{
	page = 0, mode = 1;
	Synco();
	SetWriteHandler(0x6000,0x7FFF,M51W6);
	SetWriteHandler(0x8000,0xBFFF,M51W8E);
	SetWriteHandler(0xC000,0xDFFF,M51WC);
	SetWriteHandler(0xE000,0xFFFF,M51W8E);
	SetCartRead(0x6000,0xFFFF);
}

void BMC_BallGames11in1_init(CartInfo *info)
{
	info->Power = M51Power;
	AddExState(GameMemBlock,32,0,"MPBY"); /* MPBY for backward-compatibility */
}
