/*
 boards/BMCSuperHIK.c

 * MacFCEU 0.7
 *
 * Copyright notice for this file:
 *  mmc3.cpp Copyright (C) 1998 BERO
 *  mmc3.cpp Copyright (C) 2003 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "MMC3and6.h"
#include "unlicensed.h"

/* ---- mapper 45: BMC SuperHIK 8-in-1/HERO X-in-1 */

static void M45CW(uint32 A,
	uint8 V)
{
	uint32		NV;

	if (UNIFchrrama)
		return; //do nothing if RAM
	NV = V;
	if (MMC3EXPREGS[2]&8)
		NV&= (1<<(MMC3EXPREGS[2]&7)+1)-1;
	else if (MMC3EXPREGS[2])
		NV = 0;
	NV|= MMC3EXPREGS[0];
	NV|= MMC3EXPREGS[2]<<4&0xF00;
	setchr1(A,NV);
}

static void M45PW(uint32 A,
	uint8 V)
{
	V&= MMC3EXPREGS[3]^0x3F;
	V|= MMC3EXPREGS[1];
	setprg8(A,V);
}

static DECLFW(M45_write)
{
	int		x;

	if (MMC3EXPREGS[3]&0x40)
	{
		MMC3WRAM[A-0x6000] = V;
		return;
	}
	x = MMC3EXPREGS[4];
	MMC3EXPREGS[x] = V, ++x, x&= 3;
	MMC3EXPREGS[4] = x;

	FixMMC3PRG(MMC3cmd);
	FixMMC3CHR(MMC3cmd);
}

static void M45Power(void)
{
	memset(MMC3EXPREGS,0,5); //only on power
	GenMMC3Power();
	SetWriteHandler(0x6000,0x7FFF,M45_write);
}

void BMC_SuperHeroXin1_Init(CartInfo *info)
{
	GenMMC3_Init(info,512,256,8,info->battery);
	info->Power = M45Power;
	MMC3cwrap = M45CW;
	MMC3pwrap = M45PW;
	AddExState(MMC3EXPREGS,5,0,"EXPR");
}

/* ---- mapper 49: BMC SuperHIK 4-in-1 */

static void M49PW(uint32 A,
	uint8 V)
{
	if (!(MMC3EXPREGS[0]&1))
		return;
	V&=15, V|= MMC3EXPREGS[0]>>2&0x30;
	setprg8(A,V);
}

static void M49CW(uint32 A,
	uint8 V)
{
	setchr1(A,(V&0x7F)|(MMC3EXPREGS[0]<<1&0x180));
}

static DECLFW(M49Write)
{
(void)A;
	if (MMC3A001B&0x80 && MMC3EXPREGS[0]!=V)
	{
		MMC3EXPREGS[0] = V;
		if (MMC3EXPREGS[0]&1)
			FixMMC3CHR(MMC3cmd);
		else
			setprg32(0x8000,MMC3EXPREGS[0]>>4&3);
		FixMMC3PRG(MMC3cmd);
	}
}

static void M49Power(void)
{
	MMC3EXPREGS[0] = 0;
	GenMMC3Power();
	SetWriteHandler(0x6000,0x7FFF,M49Write);
	SetReadHandler(0x6000,0x7FFF,0);
}

void BMC_SuperHIK4in1_Init(CartInfo *info)
{
	GenMMC3_Init(info,512,256,0,0);
	info->Power = M49Power;
	MMC3cwrap = M49CW;
	MMC3pwrap = M49PW;
	AddExState(MMC3EXPREGS,1,0,"EXPR");
}
