/*
 board/Event.c
  mapper 105

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  mmc1.c Copyright (C) 1998 BERO
 *  mmc1.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "MMC1.h"

/* ---- mapper 105: Event (custom) */
/* base time is 0x2000000 */

static uint32 NWCIRQCount;
static uint8 NWCRec;

#define NWCDIP 0xE

static void FP_FASTAPASS(1) NWCIRQHook(int a)
{
	if ((NWCRec&0x10)==0)
		if ((NWCIRQCount+=a)|(NWCDIP<<25)>=0x3E000000)
		{
			NWCIRQCount = 0;
			X6502_IRQBegin(FCEU_IQEXT);
		}
}

static void NWCCHRHook(uint32 A, uint8 V)
{
(void)A;
	if (V&0x10) //&& !(NWCRec&0x10))
	{
		NWCIRQCount = 0;
		X6502_IRQEnd(FCEU_IQEXT);
	}
	NWCRec = V;
	if (V&8)
		MMC1PRG();
	else
		setprg32(0x8000,V>>1&3);
}

static void NWCPRGHook(uint32 A, uint8 V)
{
	if (NWCRec&0x8)
		setprg16(A,8|(V&7));
	else
		setprg32(0x8000,NWCRec>>1&3);
}

static void NWCPower(void)
{
	GenMMC1Power();
	setchr8(0);
}

void MMC1_Event_Init(CartInfo *info)
{
	GenMMC1Init(info,256,256,8,0);
	info->Power = NWCPower;
	MMC1CHRHook4 = NWCCHRHook;
	MMC1PRGHook16 = NWCPRGHook;
	MapIRQHook = NWCIRQHook;
}
