/*
 boards/HES.c

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  113.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "latch.h"

/* ---- mapper 113: HES standard */

/* I'm *not* getting the feeling that this is another
"jam two different bank switching hardwares into one mapper."
*/

/* Deathbots
static DECLFW(Mapper113_writeh) //[0x8000,0xffff]
{
(void)A;
//printf("$%04x:$%02x\n",A,V);
ROM_BANK32(V&7);
//VROM_BANK8((V>>4)&7);
}
*/

static void HESSync(void)
{
	int	x = latch_byte, bc = x>>3;

	GameMemBlock[0] = x;
	GameMemBlock[1] = ++x;
	GameMemBlock[2] = ++x;
	GameMemBlock[3] = ++x;

	setprg32(0x8000,bc&7);
	setchr8((bc&8)|(latch_byte&7));
	setmirror(bc>>4);
}

static void HESPower(void)
{
	int	a;

	a = 0x4300;
	do
		SetWriteHandler(a,a+0xFF,Latch_Write);
	while((a+=0x200)<0x6000);
	Latch_Power();
}

static void HESRestore(int version)
{
	if (version<9816)
		latch_byte = GameMemBlock[0];
	HESSync();
}

void HES_STD_Init(CartInfo *info)
{
	Latch_Init(info,HESSync,0,0,0x410041FFU);
	GameStateRestore = HESRestore;
	AddExState(GameMemBlock,4,0,"PBL"); //some backward-compatibility
}
