/*
 boards/KayPandaPrince.c

 * MacFCEU 0.6.6
 *
 * Copyright notice for this file:
 *  121.c Copyright (C) 2007-2008 Mad Dumper, CaH4e3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * Panda prince pirate.
 * MK4, MK6, A9711 board, MAPPER 187 the same!
 * UNL6035052_Init seems to be the same too, but with prot array in reverse
 */

#include "mapinc.h"
#include "MMC3and6.h"

/*static void M121CW(uint32 A,
	uint8 V)
{
	if ((A^(MMC3_cmd<<5))&0x1000)
		setchr1(A,V);
	else
		setchr1(A,V|0x100);
}*/

static void M121PW(uint32 A,
	uint8 V)
{
	if (A==0x4000)
	{
		if (MMC3EXPREGS[0])
			V = MMC3EXPREGS[0];
	} else if (A==0x6000)
	{
		if (MMC3EXPREGS[1])
			V = MMC3EXPREGS[1];
	}
	setprg8(A,V); //&0x3F);
}

static DECLFW(M121W8)
{
	if ((A&=0x6003)==0 || --A==0)
	{
		MMC3_CMDWrite(A,V);
		goto prg;
	} else if ((A-=2)!=0)
		return;
	//3
	MMC3EXPREGS[3] = V;
	switch(V) //&0x3F
	{ //protection field
		case 0x20: MMC3EXPREGS[0] = 19; break;
		case 0x26: MMC3EXPREGS[1] = 8; break;
		case 0x28: MMC3EXPREGS[0] = 12; break;
		case 0x29: MMC3EXPREGS[1] = 27; break; //=1
		case 0xAB: MMC3EXPREGS[1] = 7; break; //0x2B
		case 0xEC: case 0xEF: MMC3EXPREGS[1] = 13; break; //0x2C
		case 0xFF: MMC3EXPREGS[1] = 9; break; //0x2F
		//case 0x3F: MMC3EXPREGS[7] = 1; break;

		default: MMC3EXPREGS[0] = 0;
	}
	//MMC3_CMDWrite(0x8000,V);
prg:
	FixMMC3PRG(MMC3cmd);
}

static DECLFW(M121W5)
{
	static uint8	prot_array[] = {0,0x83,0x42,0}; /* 1st was 0x83 */
(void)A;
	//0x100 bit in address seems to be switch arrays 0, 2, 2, 3 (Contra Fighter)
	MMC3EXPREGS[2] = prot_array[V&3];
}

static DECLFR(M121R5)
{
(void)A;
	return MMC3EXPREGS[2];
}

static void M121Power(void)
{
	MMC3EXPREGS[0] = MMC3EXPREGS[1] = MMC3EXPREGS[2] = 0;
	GenMMC3Power();
	SetReadHandler(0x5000,0x5FFF,M121R5);
	SetWriteHandler(0x5000,0x5FFF,M121W5);
	SetWriteHandler(0x8000,0x9FFF,M121W8);
}

void Kay_PandaPrince_Init(CartInfo *info)
{
	GenMMC3_Init(info,128,256,8,0);
	MMC3pwrap = M121PW;
//	MMC3cwrap = M121CW;
	info->Power = M121Power;
	AddExState(MMC3EXPREGS,4,0,"EXPR");
}
