/*
 boards/KingOfFighters.c
  need to get the actual name of the board(s)

 * MacFCEU 0.6.6
 *
 * Copyright notice for this file:
 *  187.c Copyright (C) 2003 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "MMC3and6.h"
#include "unlicensed.h"

/* ---- mapper 187: King Of Fighters 96 / SF3 */

#define ExtMode MMC3EXPREGS[0]
#define LastWr5 MMC3EXPREGS[1]
#define PRGovrd MMC3EXPREGS[2]
#define SndInit MMC3EXPREGS[3]

/*
static uint32 ppucount=0;
static uint32 ppulast=0;

static void M187Sync(void)
{
	int x;
	uint32 base=0;

	if (cmd&0x80)
		base = 0x1000;
	setchr2(0x000^base,(0x100|DRegs[0])>>1);
	setchr2(0x800^base,(0x100|DRegs[1])>>1);
	for(x=0;x<4;x++)
		setchr1((0x1000^base)+x*0x400,DRegs[2+x]);
	if(ExtMode&0x80)
		if(ExtMode&0x20)
			setprg32(0x8000,(ExtMode&0x1F)>>1);
		else
		{
			setprg16(0x8000,ExtMode&0x1F);
			setprg16(0xc000,ExtMode&0x1F);
		}
	else
	{
		setprg8(0x8000,DRegs[6]);
		setprg8(0xc000,~1);
		setprg8(0xa000,DRegs[7]);
		setprg8(0xe000,~0);
	}
}
*/

static void KOF96Sync(void)
{
	int		b = ExtMode&0x1F;

	if (ExtMode&0x20)
		setprg32(0x8000,b>>2);
	else
	{
		setprg16(0x8000,b);
		setprg16(0xC000,b);
	}

	if (PRGovrd&0x80)
	{
		if (PRGovrd&1)
			setprg8(0xA000,15);
		if (PRGovrd&2)
			setprg8(0xC000,23);
	}
}

static void KOF96PW(uint32 A,
	uint8 V)
{
	if (ExtMode&0x80)
		return;
	setprg8(A,V);
}

static void KOF96CW(uint32 A,
	uint8 V)
{
	int		b = V;

	if (((A^(MMC3cmd<<5))&0x1000)==0)
		b|= 0x100; /* FCEUX 2.1.3 has this part commented out */
	setchr1(A,b);
}

static DECLFW(KOF96Write5)
{
	LastWr5 = V;
	if (A==0x5000)
	{
		if (V==ExtMode)
			return;
		if ((ExtMode=V)&0x80)
		{
			PRGovrd = 0;
			KOF96Sync();
		} else
			FixMMC3PRG(MMC3cmd);
	} else if (!SndInit)
	{
		SndInit = 1;
		BWrite[0x4017](0x4017,0x40); //IRQFM
	}
}

static DECLFW(KOF96Write8)
{
	if ((A&=3)==0)
	{
		PRGovrd = 0;
		MMC3_CMDWrite(0x8000,V);
	} else if (--A==0) //1
	{
		if ((PRGovrd&0x80)==0)
			MMC3_CMDWrite(0x8001,V);
	} else if ((A-=2)==0) //3
	{
		PRGovrd|= 0x80;
		if (V==0x28)
			PRGovrd|= 2;
		else if (V==0x2A)
			PRGovrd|= 1;
		KOF96Sync();
	}
}

/*
static DECLFW(KOF96HWrite)
{
//if(A==0x8003 && XFrame.PC<0x800) FCEUI_DumpMem("dmp",0x0000,0xFFFF);
//printf("$%04x:$%02x, %04x\n",A,V,XFrame.PC);
	LastWr=V;

	switch(A)
	{
	case 0xc000:IRQLatch=IRQCount=V;break;
	case 0xc001:IRQCount=IRQLatch;ppulast=ppucount=0;break;
	case 0xe000:IRQa=0;X6502_IRQEnd(FCEU_IQEXT);break;
	case 0xe001:IRQa=1;break;
	case 0xa000:setmirror(mir=~V&1);break;
}
*/

static DECLFR(ProtRead)
{
	unsigned	x = LastWr5&3;
(void)A;
	if (x<=1)
		return 0x83;
	else if (x==2)
		return 0x42; //0x80
	return 0;
}

static void KOF96Restore(int v)
{
(void)v; //ain't gonna mattah; old data wasn't saved
	MMC3mwrap(MMC3A000B&1);
	FixMMC3PRG(MMC3cmd);
	FixMMC3CHR(MMC3cmd);
	KOF96Sync();
}

static void KOF96Power(void)
{
	MMC3EXPREGS[0] = MMC3EXPREGS[1] = MMC3EXPREGS[2] = MMC3EXPREGS[3] = 0;
	GenMMC3Power();
	SetWriteHandler(0x5000,0x5FFF,KOF96Write5);
	SetWriteHandler(0x8000,0x9FFF,KOF96Write8);
	SetReadHandler(0x5000,0x5FFF,ProtRead);
	SetCartRead(0x8000,0xFFFF);
}

/*
static void sl(void)
{
	if (IRQa && IRQCount>=0)
		if (--IRQCount<0)
			X6502_IRQBegin(FCEU_IQEXT);
}

static void FP_FASTAPASS(1) foo(uint32 A)
{
	if (A&0x2000 && (ppulast&0x2000)==0)
		if (++ppucount==42)
		{
			sl();
			ppucount = 0;
		}
	ppulast = A;
}
*/

void KOF96_Init(CartInfo *info)
{
	GenMMC3_Init(info,128,512,0,0); //using PRG/CHR from M91
	info->Power = KOF96Power;
	//GameHBIRQHook=sl;
//	PPU_hook = foo;
	GameStateRestore = KOF96Restore;
	AddExState(MMC3EXPREGS,4,0,"EXPR");
}
