/*
 boards/MMC1.h

  MacFCEU 0.5.5
*/

/* ---- externs */

extern uint8 MMC1DReg[4];

extern void (*MMC1CHRHook4)(uint32 A, uint8 V);
extern void (*MMC1PRGHook16)(uint32 A, uint8 V);

/* ---- prototypes */

DECLFW(MMC1_write);

void MMC1CHR(void);
void MMC1PRG(void);
void MMC1MIRROR(void);

void GenMMC1Close(void);
//no reset routine
void GenMMC1Power(void);

void GenMMC1Init(CartInfo*,
	int prg,
	int chr,
	int wram,
	int battery);

/* boards */

void SAROM_Init(CartInfo*);
void SBROM_Init(CartInfo*);
void SCROM_Init(CartInfo*);
void SEROM_Init(CartInfo*);
void SFROM_Init(CartInfo*);
void SGROM_Init(CartInfo*);
void SHROM_Init(CartInfo*);
void SJROM_Init(CartInfo*);
void SKROM_Init(CartInfo*);
void SLROM_Init(CartInfo*);
void SL1ROM_Init(CartInfo*);
void SL2ROM_Init(CartInfo*);
void SNROM_Init(CartInfo*);
void SOROM_Init(CartInfo*);

void SxROM_Init(CartInfo*); //M1
void MMC1A_Init(CartInfo*); //M155

// Event

void MMC1_Event_Init(CartInfo*); //M105
