/*
 boards/Namcot34xx.c
  3446 is handled in 16.c

 * MacFCEU 0.8a8
 *
 * Copyright notice for this file:
 *  95.c, deirom.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "Namcot.h"

/* ---- mapper 95: Namcot 3425 */
/* -- this needs to be fixed */

static uint8 DRegs[9];
#define cmd DRegs[8]
static uint8 lastA;
static uint8 MirCache[8];

static SFORMAT DB_StateRegs[] =
{
	{DRegs, 8, "DREG"},
	{&cmd, 1, "CMD"},
	{&lastA, 1, "LAST"},
	{0}
};

static void FP_FASTAPASS(1) dragonbust_ppu(uint32 A)
{ 
	static int	last = -1;
	static uint8	z;

	if (A>=0x2000)
		return;

	lastA = A>>=10;  

	z = MirCache[A];
	if (z!=last)
	{
		setmirror(MI_0+z);
		last = z;
	}
}

static void toot(void)
{
	int	x = 3;

	MirCache[0]=MirCache[1] = DRegs[0]>>4&1;
	MirCache[2]=MirCache[3] = DRegs[1]>>4&1;

	do
		MirCache[4+x] = DRegs[2+x]>>5&1;
	while(--x>=0);
	setmirror(MI_0+MirCache[lastA]);
}

static DECLFW(M95_write)
{
	A&=0xF001;
	if((A+=-0x8000)==0)
		cmd = V;
	else if((A+=0x8000-0x8001)==0)
		switch(cmd&7)
		{
		case 0: DRegs[0]=(V&0x3F)>>1;toot();V>>=1;setchr2(0x0000,V&0x1F);break;
		case 1: DRegs[1]=(V&0x3F)>>1;toot();V>>=1;setchr2(0x0800,V&0x1F);break;
		case 2: DRegs[2]=V&0x3F;toot();setchr1(0x1000,V&0x1F); break;
		case 3: DRegs[3]=V&0x3F;toot();setchr1(0x1400,V&0x1F); break;
		case 4: DRegs[4]=V&0x3F;toot();setchr1(0x1800,V&0x1F); break;
		case 5: DRegs[5]=V&0x3F;toot();setchr1(0x1C00,V&0x1F); break;
		case 6: DRegs[6]=V&0x3F;
			setprg8(0x8000,V);
			break;
		case 7: DRegs[7]=V&0x3F;
			setprg8(0xA000,V);
			break;
		}
}

static void DBSync()
{
	unsigned	x;

	setchr2(0x000,DRegs[0]);
	setchr2(0x800,DRegs[1]);

	x = 4;
	do
		setchr1(x<<10,DRegs[(2-4)+x]);
	while(++x<8);

	setprg8(0x8000,DRegs[6]);
	setprg8(0xA000,DRegs[7]);
	toot();
}

static void DBPower(void)
{
	DRegs[0] = DRegs[1] = 0x1F;
	DRegs[2] = DRegs[3] = DRegs[4] = DRegs[5] = DRegs[6] = DRegs[7] = 0x3F;

	DBSync();

	setprg8(0xC000,0x3E);
	setprg8(0xE000,0x3F);

	SetCartRead(0x8000,0xFFFF);
	SetWriteHandler(0x8000,0xffff,M95_write);
}

static void StateRestore(int v)
{
(void)v;
	DBSync();
}

void Namcot3425_Init(CartInfo *info)
{
	info->Power = DBPower;
	PPU_hook = dragonbust_ppu;
	GameStateRestore = StateRestore;
	AddExState(DB_StateRegs,~0,0,0);
}

/* ---- mapper 206: Namcot 34x3; DRROM, DEROM or DEIROM */

static SFORMAT	DxROM_StateRegs[] =
{
	{&cmd, 1, "CMD"},
	{DRegs, 8, "DREG"},
	{0}
};

static void DxROMSync(void)
{
	unsigned	x;

	setchr2(0x000,DRegs[0]);
	setchr2(0x800,DRegs[1]);
	x = 4;
	do
		setchr1(x<<10,DRegs[(2-4)+x]);
	while(++x<8);

	setprg8(0x8000,DRegs[6]);
	setprg8(0xA000,DRegs[7]);
}

static void DxROMRestore(int v)
{
(void)v;
	DxROMSync();
}

static DECLFW(DxROMwrite)
{
	if ((A&1)==0)
		{cmd = V&7; return;}
	/*0x8001*/
	if (cmd<=5)
	{
		V&= 0x3F;
		if (cmd>1)
			V|= 0x40; //bank expansion?
		else
			V>>= 1;
	} else
		V&= 0x0F;
	DRegs[cmd&7] = V;
	DxROMSync();
}

static void DxROMPower(void)
{
	dwmemset(DRegs,0,sizeof(DRegs));
	setprg8(0xC000,14);
	setprg8(0xE000,15);
	DxROMSync();
	SetCartRead(0x8000,0xFFFF);
	SetWriteHandler(0x8000,0x9FFF,DxROMwrite);
}

void DxROM_Init(CartInfo *info)
{
	info->Power = DxROMPower;
	GameStateRestore = DxROMRestore;
	AddExState(&DxROM_StateRegs,~0,0,0);
}
