/*
 boards/Nitra.c

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  mapper 250 Copyright (C) 2003 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "MMC3and6.h"

/* ---- mapper 250: Nitra TDA */

static DECLFW(M250_CMDwrite)
{
(void)A; (void)V;
	MMC3_CMDWrite((A&0xE000)|(A>>10&1),A&0xFF);
}

static DECLFW(M250_IRQWrite)
{
(void)V;
	MMC3_IRQWrite((A&0xE000)|(A>>10&1),A&0xFF);
}

static void M250Power(void)
{
	GenMMC3Power();
	SetWriteHandler(0x8000,0xBFFF,M250_CMDwrite);
	SetWriteHandler(0xC000,0xFFFF,M250_IRQWrite);
}

void Nitra_TDA_Init(CartInfo *info)
{
	GenMMC3_Init(info,512,256,8,info->battery);
	info->Power = M250Power;
}
