/*
 boards/karaoke.c
  Bandai mapper 188 -- needs to be updated

 * MacFCEU 0.6.4
 *
 * Copyright notice for this file:
 *  karaoke.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"
#include "Bandai.h"

static uint8	DReg;

static SFORMAT	StateRegs[] =
{
	{&DReg,1,"DREG"},
	{0}
};

static void Sync(void)
{
//if(!DReg)
//printf("%02x\n",DReg);
	if (DReg)
		if(DReg&0x10)
			setprg16(0x8000,DReg&7);
		else
			setprg16(0x8000,(DReg&7)|8);
	else
		setprg16(0x8000,7);
}

static DECLFW(M188Write)
{
(void)A;
	DReg = V;
	Sync();
}

static DECLFR(testr)
{
(void)A;
	return 3;
}

static void StateRestore(int v)
{
(void)v;
	Sync();
}

static void Power(void)
{
	setchr8(0);
	setprg8(0xc000,14);
	setprg8(0xe000,15);
	DReg = 0;
	Sync();
	SetReadHandler(0x6000,0x7FFF,testr);
	SetCartRead(0x8000,0xFFFF);
	SetWriteHandler(0x8000,0xFFFF,M188Write);
}

void Bandai_Karaoke_Init(CartInfo *info)
{
	info->Power = Power;
	GameStateRestore = StateRestore;
	AddExState(&StateRegs,~0,0,0);
}
