/*
 boards/latch.h

  MacFCEU 0.6.6
*/

/* ---- externs */

extern uint8 latch_byte;
extern uint16 latch_addr;

/* ---- prototypes */

DECLFW(Latch_Write);
DECLFW(Latch_BusWrite);

void Latch_Power(void);

/* the busread bit tells the Power function to use a bus-conflict routine */
void Latch_Init(CartInfo *info,
	void (*wsyncproc)(void),
	readfunc rfunc,
	uint32 init, /* [initbyte.8] [busread.1] [ctrlmask.7] [initaddr.16] */
	uint32 addrlohi);

/* boards */

void UxROM_Init(CartInfo*); //M2
void UN1ROM_Init(CartInfo*); //M94
void CNROM_Init(CartInfo*); //M3
void AxROM_Init(CartInfo*); //M7
void AGCI47516_Init(CartInfo*); //M11
void AGCI50282_Init(CartInfo*); //M144
void CPROM_Init(CartInfo*); //M13
void BNROM_Init(CartInfo*); //M34

void GNROM_Init(CartInfo*); //M66 when PRG64KB
void MHROM_Init(CartInfo*); //M66

void JF14x_Init(CartInfo*); //M140
void JF16_Init(CartInfo*); //M78

void AVE_NINA06_Init(CartInfo*); //M79

void Sunsoft2A_Init(CartInfo*); //M93

void CandE_SHLZ_Init(CartInfo*); //M240

void Discrete_74_139_74_Init(CartInfo*); //M87
void Discrete_74_161_161_32A_Init(CartInfo*); //M70
void Discrete_74_161_161_32B_Init(CartInfo*); //M152
void Discrete_74_161_138_Init(CartInfo*); //M38

void HES_STD_Init(CartInfo*); //M113

void Magic_Series_Init(CartInfo*); //M107

void T3H53_Init(CartInfo*); //M59 --is this licensed?  how many of these are?

void AE_A52_Init(CartInfo*); //M228
