/*
 common/dface.h
  note that a number of prototypes defined here are n/a in MacFCEU

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef  __cplusplus
extern "C" {
#endif

//#include "/args.h"
#include "/config.h"

#include "/input.h"

extern struct FCEUGI *CurGame;

extern CFGSTRUCT DriverConfig[];
//extern ARGPSTRUCT DriverArgs[];
extern char *DriverUsage;

void DoDriverArgs(void);
uint8 *GetBaseDirectory(void);

int InitSound(struct FCEUGI *gi);
int KillSound(void);
uint32 GetMaxSound(void);

/* these are now strictly native functions, if used at all; 2009.12.17 17:13 EST */
/*void WriteSound(int16 *Buffer, int Count);*/
/*uint32 GetWriteSound(void);*/

void SilenceSound(int s); /* DOS and SDL */

int InitMouse(void);
void KillMouse(void);
void GetMouseData(uint32 *MouseData);

int InitJoysticks(void);
int KillJoysticks(void);
uint32 *GetJSOr(void);

int InitKeyboard(void);
int UpdateKeyboard(void);
char *GetKeyboard(void);
void KillKeyboard(void);

int InitVideo(struct FCEUGI *gi);
int KillVideo(void);

#ifdef mac
void BlitScreen(const uint8 *XBuf,
	int rowsize,
	const struct Rect *blitrect,
	const struct PixMap **dstblitmap);
#else
void BlitScreen(uint8 *XBuf);
#endif

void LockConsole(void);
void UnlockConsole(void);
void ToggleFS();		/* SDL */

int LoadGame(const char *path);
int CloseGame(void);
int GUI_Init(int argc, char **argv, int (*dofunc)(void));
int GUI_Idle(void);
int GUI_Update(void);
void GUI_Hide(int);
void GUI_RequestExit(void);
int GUI_SetVideo(int fullscreen, int width, int height);
char *GUI_GetKeyboard(void);
void GUI_GetMouseState(uint32 *b, int *x, int *y);

void UpdatePhysicalInput(void);
int DTestButton(ButtConfig *bc);
int DWaitButton(const uint8 *text, ButtConfig *bc, int wb);
int ButtonConfigBegin(void);
void ButtonConfigEnd(void);

void Giggles(int);
void DoFun(void);

#ifdef  __cplusplus
}
#endif
