/*
 file.h

  MacFCEU 0.8

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

typedef struct FCEUFILE/*(6+)*/
{
	void	*fp;	// FILE* or ptr to ZIPWRAP
	uint8	type;	// 0=normal file, 1=gzip, 2=zip, 3=ips -- was uint32
} FCEUFILE;


FCEUFILE *FCEU_fopen(const char *path,
	const char *ipsfn,
	const char *mode,
	const char *ext, /* this extension only in archive matches */
	char *outname,
	int *err); /* return error code (optional) */
int FCEU_fclose(FCEUFILE*);

/* `size_t` -> `unsigned long` so <std*> isn't required; 2010.01.05 */
long int FCEU_fread(void *ptr,
	unsigned long size,
	unsigned long nmemb,
	FCEUFILE*);
long int FCEU_fwrite(void *ptr,
	unsigned long size,
	unsigned long nmemb,
	FCEUFILE*);

/* `offset` was prev. `long`, should be `long int`; 2010.01.05 */
int FCEU_fseek(FCEUFILE*,
	long int offset,
	int whence);

long int FCEU_ftell(FCEUFILE*);

void FCEU_rewind(FCEUFILE*);

int FCEU_read32le(uint32 *Bufo,
	FCEUFILE*);
int FCEU_read16le(uint16 *Bufo,
	FCEUFILE*);

int FCEU_fgetc(FCEUFILE*);

long int FCEU_fgetsize(FCEUFILE*);

int FCEU_fisarchive(FCEUFILE*);


/* selecting a name within an archive - FCEUX feature; 2012.03.30 */

int FCEUI_SelectName(const char*,
	int count);
