/*
 fsound.h

 * MacFCEU 0.9
 *
 * Copyright notice for this file:
 *  sound.h Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* ---- constants */

#define SCVRC6			0
#define SCVRC7			1
#define SCNFDS			2
#define SCMMC5			3
#define SCN106			4
#define SCSFME			5

/* ---- typedefs */

typedef void (*voidfunc)(void);
typedef void (*fillfunc)(int32 c);

typedef struct EXPSOUND
{
	fillfunc Fill[6]; /* low/mid-quality expansion sound */
	voidfunc HiFill[6];
	fillfunc HiSync[6];
	voidfunc RChange[6];

	/* NeoFill is for sound devices (only VRC7, currently)
	   that are emulated in a more high-level manner in HQ mode.
	   Interestingly, this device has slightly better sound quality
	   (updated more often) in lq mode than in high-quality mode.
	   Maybe that should be fixed. :)
	*/
	void (*NeoFill)(int16 *Wave,
		int Count);
	void (*Kill)(void);
} EXPSOUND;

/* ---- externs */

extern EXPSOUND GameExpSound;

extern int32 nesincsize, Soundfccnt;
extern uint8 SIRQStat;

/* WaveFinal's static */
extern int32 FCEUWave[13472];

extern uint32 soundtsinc;
extern uint32 soundtsoffs;

#define SOUNDTS			(timestamp+soundtsoffs)

/* ---- prototypes */

void FCEU_SetSoundVariables(void);

/* sound output is now int16, as data was already clipped that range */
int FASTAPASS(1) GetSoundBuffer(int16 **W);
int FlushEmulateSound(void);

void SetNESSoundMap(void);
void FrameSoundUpdate(void);

void FCEUSND_Power(void);
void FCEUSND_Reset(void);
void FCEUSND_SaveState(void);
void FCEUSND_LoadState(int version);

void FASTAPASS(1) FCEU_SoundCPUHook(int);
