/*
 git.h

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __FCEU_GIT
/* Mmm...git. Almost as funny as "gimp". */
#define GIT_CART	0	/* Cart. */
#define GIT_VSUNI	1	/* VS Unisystem. */
#define GIT_FDS		2	/* Famicom Disk System. */
#define GIT_NSF		3	/* NES Sound Format. */

#define GIV_NTSC	0	/* NTSC emulation. */
#define GIV_PAL		1	/* PAL emulation. */
#define GIV_USER	2	/* What was set by FCEUI_SetVidSys(). */

typedef struct FCEUGI
{
	uint8	*name;		/* Game name, UTF8 or native encoding */

	int	type;		/* GIT_* */
	int	vidsys;		/* Current emulated video system; GIV_* */
	int	input[2];	/* Desired input for emulated input ports 1 and 2; -1
				   for unknown desired input. */
	int	inputfc;	/* Desired Famicom expansion port device. -1 for unknown
				   desired input. */
	int	cspecial;	/* Cart expansion: DIP switches, barcode reader, etc. */
	uint8	MD5[16];
	int	soundrate;	/* Expansion sound support.  0 for default. */
	int	soundchan;	/* Number of sound channels. */
} FCEUGI;

#define __FCEU_GIT
#endif
