/*
 Cursor.c
  FCE Ultra

  MacFCEU 0.9
*/

#include "share.h"
#include "../video.h"

#define K PAL_BLACK^1
#define W PAL_WHITE^1
#define D PAL_BGRAY^1
#define T 0

static const uint8 GunSight[13*13]={
 T,T,T,T,T,T,W,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,W,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,T,T,T,T,T,T,T,
 T,T,T,T,T,T,D,T,T,T,T,T,T,
 W,K,W,K,T,D,D,D,T,K,W,K,W,
 T,T,T,T,T,T,D,T,T,T,T,T,T,
 T,T,T,T,T,T,T,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,W,T,T,T,T,T,T,
 T,T,T,T,T,T,K,T,T,T,T,T,T,
 T,T,T,T,T,T,W,T,T,T,T,T,T,
};
static const uint8 FCEUcursor[11*19]=
{
 W,T,T,T,T,T,T,T,T,T,T,
 W,W,T,T,T,T,T,T,T,T,T,
 W,K,W,T,T,T,T,T,T,T,T,
 W,K,K,W,T,T,T,T,T,T,T,
 W,K,K,K,W,T,T,T,T,T,T,
 W,K,K,K,K,W,T,T,T,T,T,
 W,K,K,K,K,K,W,T,T,T,T,
 W,K,K,K,K,K,K,W,T,T,T,
 W,K,K,K,K,K,K,K,W,T,T,
 W,K,K,K,K,K,K,K,K,W,T,
 W,K,K,K,K,K,W,W,W,W,W,
 W,K,K,W,K,K,W,T,T,T,T,
 W,K,W,T,W,K,K,W,T,T,T,
 W,W,T,T,W,K,K,W,T,T,T,
 W,T,T,T,T,W,K,K,W,T,T,
 T,T,T,T,T,W,K,K,W,T,T,
 T,T,T,T,T,T,W,K,K,W,T,
 T,T,T,T,T,T,W,K,K,W,T,
 T,T,T,T,T,T,T,W,W,T,T,
};

#undef K
#undef W
#undef D
#undef T

/* macro blitter; 2008.06.29 12:58 GMT; removed indexed mode; 2008.06.30 16:32 GMT */
#define _clippedpixloop(d,z,c,s,w,h,x,y,e)		do{ \
 const uint8 *__s=s; uint8 *__d=buf; int __c=(y)+h,__z=(x)+w; \
 if(__z>z) __z=z; if(__c>c) __c=c; /* clip bottom-right */ \
 if((__z-=(x))<=0||(__c-=(y))<=0||(x)<=-w||(y)<=-h) { /* restore, test */ \
  if((y)<0) __s-=(y)*w; else __d+=(y)*z; /* adjust left */ \
  if((x)<0) __s-=(x); else __d+=(x); /* adjust top */ \
  do{int __x=__z; uint8 *__w=__d; const uint8 *__r=__s; do{uint8 __a; \
    if((__a=*__r++)!=0) {e;}}while(++__w,--__x!=0);} \
while(__s+=w,__d+=z,--__c!=0);}}while(0)

void FCEU_DrawGunSight(uint8 *buf, int xc, int yc)
{
 xc-=7,yc-=7;
 _clippedpixloop(buf,FCEUSCRN_ROWSIZE,240,GunSight,13,13,xc,yc,
	if(__a==PAL_BGRAY) *__w^=0x7F; else *__w=__a^1);
}

void FCEU_DrawCursor(uint8 *buf, int xc, int yc)
{
 _clippedpixloop(buf,FCEUSCRN_ROWSIZE,240,FCEUcursor,11,19,xc,yc,*__w=__a);
}
