/*
 input/Shadow.c
  so many redundant functions (modeled after the Zapper)

 * MacFCEU 0.9d3
 *
 * Copyright notice for this file:
 *  shadow.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <string.h>
#include <stdlib.h>

#include "share.h"
#include "Zapper.h"

#define ZD	InputZapperData[2]

static void FP_FASTAPASS(3) ShadowScan(uint8 *bg,
	uint8 *spr,
	uint32 linets,
	int final)
{
	ZapperFrapper(2,bg,spr,linets,final);
}

static INLINE int CheckColor(void)
{
	uint64		t, u;

	FCEUPPU_LineUpdate();
	t = ZD.zaphit, u = timestampbase;
//if((ZD.zaphit+10)>=(timestampbase+timestamp)) return(0);
	(void)uint64addu32(t,10);
	(void)uint64addu32(u,timestamp);
	return int64ge(t,u) ? 0:1; //2011.02.05
}

static uint8 FP_FASTAPASS(2) ReadZapper(int w, uint8 ret)
{
	if (w)
	{
		ret&=~0x18;
		if (ZD.bogo)
			ret|= 0x10;
		ret|= CheckColor()<<3; //if...ret|= 8;
	} else
	{
		//printf("Kayo: %d\n",ZD.zap_readbit);
		ret&=~2;
		//if(ZD.zap_readbit==4) ret|=ZD.mzb&2;
		ret|= ret<<1&2;
		//ZD.zap_readbit++;
	}
	return ret;
}

static void FP_FASTAPASS(2) DrawZapper(uint8 *buf, int arg)
{
	if (arg)
		FCEU_DrawCursor(buf,ZD.mzx,ZD.mzy);
}

static void FP_FASTAPASS(2) UpdateZapper(void *data, int arg)
{
	uint32	*ptr = (uint32*)data;
(void)arg;
	if (ZD.bogo)
		--ZD.bogo;
	if (ptr[2]&1 && !(ZD.mzb&1))
		ZD.bogo = 5;

	ZD.mzx = ptr[0];
	ZD.mzy = ptr[1];
	ZD.mzb = ptr[2];
}

static void StrobeShadow(void)
{
	ZD.zap_readbit = 0;
}

static INPUTCFC SHADOWC={ReadZapper,0,StrobeShadow,UpdateZapper,ShadowScan,DrawZapper};

INPUTCFC *FCEU_InitSpaceShadow(void);
INPUTCFC *FCEU_InitSpaceShadow(void)
{
	memset(&ZD,0,sizeof(ZAPPER));
	return(&SHADOWC);
}


