/*
 macos/debugcheat.c
  this lil bugger is included in debugger.c

  Created: 2009.09.22
  Revised: 2012.01.05
*/

#include "../cheat.h"

static int cheatsrequired(void)
{
	if (GI->type==GIT_NSF)
	{
		FCEU_printf("Debug: Sorry, you cant cheat with NSFs.");
		return 0;
	}

	return 1;
}

static int cheat_proc(int argc, char const*const*argv)
{
	const char	*name = *argv++;
	long int	i = -1;
	int		c = 7, compare = 0, status = 1, type = 1;
	uint32		a = 0;
	uint8		v = 0;
	int		mode = argc<=0;

	if (argc<0)
	{ /* help message */
		if (++argc<=0)
			FCEU_printf(
"%s [add|index toggle|[address value [status [compare]]]]\n"
" - set or display cheat (no params to display all)\n",
				name);
		return 0;
	}

	if (!cheatsrequired())
		return 1;

	if (argc!=0) /* when printing list with prevcount, otherwise continue */
	{
		const char	*cname;

		prevcount = 0;
		if (--argc==0)
			goto list;
		c = 1;
		if (strcasecmp(argv[1],"add")==0)
			mode = 2;
		else if (sreadanyinteger(*++argv,&i)==NULL || i<0)
		{
			FCEU_printf("%s: index must be >=0.  ('%s')\n",
				name,*argv);
			return argc;
		}
		prevcount = i;

		if (--argc==0)
			goto list;
		if (strcasecmp(cname=*++argv,"toggle")==0 && mode<=1)
		{
			FCEUI_ToggleCheat(prevcount);
			--argc;
			goto end;
		} else if (*cname=='"' || *cname=='\'')
			--argc, ++argv;
		else
			cname = NULL;
		if (i>=0)
			FCEUI_GetCheat(prevcount,NULL,&a,&v,&compare,&status,&type);

		if (--argc==0)
			goto set;
		if (sreadanyinteger(*argv,&i)==NULL || (a=i)>0xFFFF)
		{
			FCEU_printf("%s: address must be in [0,$FFFF].  ('%s')\n",
				name,*argv);
			return argc;
		}

		if (--argc==0)
			goto set;
		if (sreadanyinteger(*++argv,&i)==NULL || (v=i)>0xFF)
		{
			FCEU_printf("%s: value must be in [0,$FF].  ('%s')\n",
				name,*argv);
			return argc;
		}

		if (--argc==0)
			goto set;
		if (sreadanyinteger(*++argv,&i)==NULL)
		{ /* status param is null and void in this case */
			FCEU_printf("%s: status must be an integer.  ('%s')\n",
				name,*argv);
			return argc;
		}
		status = i;

		if (--argc!=0)
		{
			if (sreadanyinteger(*++argv,&i)==NULL)
			{
				FCEU_printf("%s: compare value must be an integer.  ('%s')\n",
					name,*argv);
				return argc;
			}
			compare = i, type = 0;
		}
	set:
		if (mode==2)
		{
			if (FCEUI_AddCheat(cname,a,v,compare,type)==0)
			{
				FCEU_printf("Debug: could not add cheat.\n");
				return 1;
			}
			FCEU_printf("Debug: cheat added.\n");
			goto end;
		} else if (FCEUI_SetCheat(prevcount,cname,a,v,compare,status,type)==0)
		{
			FCEU_printf("Debug: could not set cheat #%u.\n",
				prevcount);
			return 1;
		}
	}
list:
	if (mode==0)
	{
		char	*dummy;

		if (FCEUI_GetCheat(0,&dummy,&a,&v,&compare,&status,&type)==0)
		{ /* 2010.04.05 */
			FCEU_printf("Debug: no cheats defined\n");
			goto end;
		} else
			FCEU_printf("Debug: listing cheat(s)...\n");
	}

	do
	{
		char	*name;

		if (FCEUI_GetCheat(prevcount,&name,&a,&v,&compare,&status,&type)==0)
			{prevcount = 0; break;} /* came to end; reset */
		if (type==0)
			FCEU_printf("#% 6u  A:$%04X  V:$%02X  S:%d  C:$%02X  N:%s.\n",
				prevcount,a,v,status,compare,type,name);
		else
			FCEU_printf("#% 6u  A:$%04X  V:$%02X  S:%d  N:%s.\n",
				prevcount,a,v,status,type,name);
	} while(++prevcount,--c!=0);
end:
	return argc>0 ? argc+1:0;
}

static int delcheat_proc(int argc, char const*const*argv)
{
	const char	*name = argv[0];
	long int	i;

	if (argc<=0)
	{ /* help message */
		if (++argc<=0)
			FCEU_printf(
"%s[heat] flush [filename] | all | index [index...]\n"
" - delete a cheat by index or all, flush (possibly to file)\n",
				name);
		return 0;
	}

	if (!cheatsrequired())
		return 1;

	if (--argc!=0 && (uint8)(*argv[1]+-'0')>(uint8)9)
		if (strcasecmp(argv[1],"flush")==0)
		{
			if (argc<=1)
				FCEU_FlushGameCheats(NULL,1);
			else
			{
				FILE		*f;
				const char	*s = *(argv+=2);
				int32		v;

				--argc;
				memset(linebuf,0,sizeof(linebuf));
				if (parse_textloop(s+1,s+strlen(s),*s,&v,NULL,NULL,0,strprinter)[0])
				{
					FCEU_printf("%s: bad parameter.  ('%s')\n",
						name,s);
					return 1;
				}
				if ((f=fopen((const char*)linebuf,"rb"))==NULL)
				{
					FCEU_printf("%s: couldnt open file.  ('%s')\n",
						name,linebuf);
					return 1;
				}
				FCEU_FlushGameCheats(f,1);
				fclose(f);
			}
			return argc==1 ? 0:argc;
		} else if (strcasecmp(argv[1],"all")==0)
		{
			FCEU_FlushGameCheats(NULL,0);
			return argc==1 ? 0:argc;
		} else
		{ /* no other options implemented */
			FCEU_printf("%s: unrecognized option '%s'.\n",
				name,argv[1]);
			return 1;
		}

	do
	{
		if (sreadanyinteger(*++argv,&i)==NULL || i<0)
		{
			FCEU_printf("%s: index must be be >=0.  ('%s')\n",
				name,*argv);
			return argc;
		}

		if (FCEUI_DelCheat(i)==0)
			FCEU_printf("%s: no cheat exists for #%u.\n",
				name,(uint32)i);
		else /* note that the entries above it move down */
			FCEU_printf("%s: cheat #%u cleared.\n",
				name,(uint32)i);
	} while(--argc!=0);

	return 0;
}
