/*
 macos/keyscan.h

  Created: 2008.08.14
  Revised: 2015.06.21
*/

/* high-order bit indexed */
#define MAP_GRAVE		53
#define MAP_0D			13 /* same place as grave, different keyboard */
#define MAP_1			21
#define MAP_2			20
#define MAP_3			19
#define MAP_4			18
#define MAP_5			16
#define MAP_6			17
#define MAP_7			29
#define MAP_8			27
#define MAP_9			30
#define MAP_0			26
#define MAP_MINUS		28
#define MAP_EQUAL		31
#define MAP_BACKSPACE		52
#define MAP_TAB			55
#define MAP_Q			11
#define MAP_W			10
#define MAP_E			9
#define MAP_R			8
#define MAP_T			22
#define MAP_Y			23
#define MAP_U			39
#define MAP_I			37
#define MAP_O			24
#define MAP_P			36
#define MAP_BRACKET_LEFT	38
#define MAP_BRACKET_RIGHT	25
#define MAP_BACKSLASH		45
#define MAP_CAPSLOCK		62
#define MAP_A			7
#define MAP_S			6
#define MAP_D			5
#define MAP_F			4
#define MAP_G			2
#define MAP_H			3
#define MAP_J			33
#define MAP_K			47
#define MAP_L			34
#define MAP_SEMICOLON		46
#define MAP_APOSTROPHE		32
#define MAP_RETURN		35
#define MAP_Z			1
#define MAP_X			0
#define MAP_C			15
#define MAP_V			14
#define MAP_B			12
#define MAP_N			42
#define MAP_M			41
#define MAP_COMMA		44
#define MAP_PERIOD		40
#define MAP_SLASH		43

/* unfortunately, only one bit is cast for each */
#define MAP_COMMAND		48
#define MAP_CONTROL		60
#define MAP_OPTION		61
#define MAP_SHIFT		63

#define MAP_SPACE		54

#define MAP_SCROLLLOCK		108 /* F14 */
/* Keys in the key pad area. */
#define MAP_NUMLOCK		64 /* NumLock/Clear */
#define MAP_HOME		116
#define MAP_CURSORLEFT		124
#define MAP_END			112
#define MAP_CURSORUP		121
#define MAP_CURSORDOWN		122
#define MAP_INSERT		117 /* Ins/Help */
#define MAP_PAGEUP		115
#define MAP_CURSORRIGHT		123
#define MAP_PAGEDOWN		126
#define MAP_DELETE		114
#define MAP_KP_SLASH		76
#define MAP_KP_ASTERISK		68
#define MAP_KP_MINUS		73
#define MAP_KP_PLUS		66
#define MAP_KP_ENTER		75
#define MAP_KP_PERIOD		70
#define MAP_KP0			85
#define MAP_KP1			84
#define MAP_KP2			83
#define MAP_KP3			82
#define MAP_KP4			81
#define MAP_KP5			80
#define MAP_KP6			95
#define MAP_KP7			94
#define MAP_KP8			92
#define MAP_KP9			91

#define MAP_ESCAPE		50
#define MAP_F1			125
#define MAP_F2			127
#define MAP_F3			100
#define MAP_F4			113
#define MAP_F5			103
#define MAP_F6			102
#define MAP_F7			101
#define MAP_F8			99
#define MAP_F9			98
#define MAP_F10			106
#define MAP_F11			96
#define MAP_F12			104
#define MAP_F13			110
#define MAP_F14			108
#define MAP_F15			118

#define MKK_COUNT 128
#define MKK(k) MAP_##k

/*#define KEY(__a) ((keys[MKK(__a)>>3]<<(MKK(__a)&7))&0x80)*/
