/*
 macos/macfceu.r

  Created: 2008.06.16
  Revised: 2015.08.21
*/

#define WIND_RezTemplateVersion		1

#include "Processes.r"
#include "Dialogs.r"
#include "MacWindows.r"
#include "Menus.r"
#include "MacTypes.r"
#include "Icons.r"
#include "Controls.r"

#ifndef DOWNSAMPLE_HIGH
 #define DOWNSAMPLE_HIGH 0
#endif

#include "shell.h"
#include "shellmenus.h"
#include "macdialogs.h"
#include "macinput.h"
#include "macvideo.h"

#define plainItem			noIcon, noKey, noMark, plain

/* process */

#ifndef NO_SIZE
 #define applicationProcessFlags \
  reserved, acceptSuspendResumeEvents, reserved, canBackground, \
  notMultiFinderAware, backgroundAndForeground, dontGetFrontClicks, ignoreChildDiedEvents, \
  is32BitCompatible, isHighLevelEventAware, onlyLocalHLEvents, notStationeryAware, \
  dontUseTextEditServices, notDisplayManagerAware, reserved, reserved
#endif

#ifdef applicationProcessFlags
resource 'SIZE'(-1)
{
	applicationProcessFlags,
	4608*1024, 2700*1024 /* Finder suggested size, bare minimum size */
};

resource 'SIZE'(1)
{
	applicationProcessFlags,
	4096*1024, 3072*1024 /* prefered size, minimum size */
};

resource 'SIZE'(0)
{
	applicationProcessFlags,
	4096*1024, 3072*1024 /* prefered size, minimum size */
};
#endif

/* dialogs */

resource 'ALRT'(alertid_fatal,"Fatal")
{
	{ 90, 88,210,420}, alertid_fatal,
	silentStages,
	alertPositionMainScreen
};
resource 'DITL'(alertid_fatal)
{
	{
		{ 84,206,106,284}, Button{enabled,"Quit"},
		{  8, 48, 72,324}, StaticText{disabled,"^0 ^1\n^2"},
		{  8,  8, 40, 40}, Icon{disabled, 0}
	}
};

resource 'DLOG'(dialogid_error,"Error")
{
	{ 90, 88,210,432}, movableDBoxProc,
	invisible, noGoAway, 'err!', dialogid_error,
	"",
	alertPositionMainScreen
};
resource 'DITL'(dialogid_error,purgeable)
{
	{
		{ 84,212,106,290}, Button{enabled,"OK"},
		{  8, 48, 72,336}, StaticText{disabled,"Place blather here."},
		{104, 12,120,100}, StaticText{disabled,"^0"},
		{  8,  8, 40, 40}, Icon{disabled, 0}
	}
};

resource 'DLOG'(dialogid_note,"Note",purgeable)
{
	{100,100,252,504}, movableDBoxProc,
	invisible, noGoAway, 'note', dialogid_note,
	"",
	centerParentWindowScreen
};
resource 'DITL'(dialogid_note)
{
	{
		{116,272,138,342}, Button{enabled,"OK"},
		{  8, 44,104,398}, StaticText{disabled,""},
		{104, 12,120,100}, StaticText{disabled,"^0"},
		{  8,  8, 40, 40}, Icon{disabled, 1}
	}
};
resource 'dctb'(dialogid_note)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'DLOG'(dialogid_accept,"Accept",purgeable)
{
	{100,100,252,520}, movableDBoxProc,
	invisible, noGoAway, 'acpt', dialogid_accept,
	"",
	centerParentWindowScreen
};
resource 'DITL'(dialogid_accept)
{
	{
		{116, 280, 138, 370}, Button{enabled,"Accept"},
		{116, 180, 138, 264}, Button{enabled,"Cancel"},
		{8, 48, 104, 412}, StaticText{disabled,""},
		{104, 12, 120, 100}, StaticText{disabled,"^0"},
		{8, 8, 40, 40}, Icon{disabled, 1}
	}
};
resource 'dctb'(dialogid_accept)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'DLOG'(dialogid_confirm,"Confirm")
{
	{100,100,232,520}, movableDBoxProc,
	invisible, noGoAway, 'cfrm', dialogid_confirm,
	"",
	centerParentWindowScreen
};
resource 'DITL'(dialogid_confirm)
{
	{
		{ 98,282,120,362}, Button{enabled,"Yes"},
		{ 98,180,120,266}, Button{enabled,"No"},
		{  8, 48, 88,412}, StaticText{disabled,""},
		{ 88, 12,104,100}, StaticText{disabled,"^0"},
		{  8,  8, 40, 40}, Icon{disabled, 2}
	}
};
resource 'dctb'(dialogid_confirm)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'DLOG'(dialogid_about,"About",purgeable)
{
	{100,100,252,436}, noGrowDocProc,
	invisible, goAway, 'abou', dialogid_about,
	"About this program...",
	centerParentWindowScreen
};
resource 'DITL'(dialogid_about)
{
	{
		{116,192,138,272}, Button{enabled,"OK"},
		{  8,  8,104,328}, StaticText{disabled,""},
		{104, 12,120,100}, StaticText{disabled,"^0"},
	}
};
resource 'dctb'(dialogid_about)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'DLOG'(dialogid_value,"Value")
{
	{100,100,168,484}, movableDBoxProc,
	invisible, noGoAway, 'valu', dialogid_value,
	"",
	centerParentWindowScreen
};
resource 'DITL'(dialogid_value)
{
	{
		{ 34,272, 56,352}, Button{enabled,"Okay"},
		{ 34,170, 56,256}, Button{enabled,"Cancel"},
		{  8,  8, 24,376}, EditText{enabled,""},
	}
};
resource 'dctb'(dialogid_value)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

#if 0
resource 'DITL'(dialogid_getfilepath,"failed attempt (well, i quit)")
{
	{ /* closebox is for cancel */
		{176,266,198,338}, Button{enabled,"Open"},
		{ 32,  8,160,328}, UserItem{enabled},
		{  8, 12, 24,204}, StaticText{enabled,""},
		{200, 48,220,224}, UserItem{enabled}, /* 4 */
		{175, 24,191,248}, EditText{enabled,"Jar-jar sucked big-EE time"},
		{  8,212, 24,228}, Icon{disabled,80},
		{  8,212, 24,276}, UserItem{enabled}
	}
};
resource 'DLOG'(dialogid_getfilepath,"getfilepath")
{
	{ 64, 64,300,416}, noGrowDocProc, invisible, goAway,
	'gfpd', dialogid_getfilepath,
	"",
	alertPositionParentWindowScreen
};
resource 'dctb'(dialogid_getfilepath)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'ICON'(80)
{
	$"00000000 00000000 00060000 000B0000"
	$"00138000 0027C000 004FE000 009FF000"
	$"013FF800 027FFC00 04FFFE00 09FFFF00"
	$"1BFFFF80 3FFFFFC0 003FC000 003FC000"
	$"003FC000 003FC000 003FC000 003FC000"
	$"003FC000 003FC000 003FC000 003FC000"
	$"003FC000 003FC0"
};

data 'ICON'(81)
{
	$"0C000020 13000020 70C00020 5C300050"
	$"470CE38E 41C31850 40700620 401C0220"
	$"400C0320 40060100 4003B080 4000FC40"
	$"40000740 40000140 40000340 400001C0"
	$"400003C0 400003C0 400003C0 400003C0"
	$"600003C0 380003C0 0E0003C0 038003C0"
	$"00E003C0 003803E8 000E03D4 000383EA"
	$"0000E3D5 00003BEA 00000FD4 000003A0"
};

resource 'cicn'(80)
{
	8, {0, 0, 16, 16}, 4,
	$"03000780 0FC01FE0 3FF07FF8 07800780"
	$"07800780 07800780 00000000 00000000",
	$"03000780 0FC01FE0 3FF07FF8 07800780"
	$"07800780 07800780 00000000 00000000",
	{
		65535, 65535, 65535,
		4369, 4369, 4369,
		8738, 8738, 8738,
		26214, 26214, 26214,
		43690, 43690, 43690, /* 4 */
		17476, 17476, 17476,
		21845, 21845, 21845,
		34952, 34952, 34952
	},
	$"00000033 00000000 00000343 10000000"
	$"00003473 31000000 00034733 33100000"
	$"00377636 66610000 03332236 22221000"
	$"00000136 20000000 00000136 20000000"
	$"00000136 20000000 00000136 20000000"
	$"00000155 20000000 00000111 10000000"
	$"00000000 00000000 00000000 00000000"
	$"00000000 00000000 00000000 00000000"
};

data 'cicn'(81)
{
	$"00000000 80100000 00000020 00200000"
	$"00000000 00000048 00000048 00000000"
	$"00040001 00040000 00000000 00000000"
	$"00000000 00000004 00000000 00200020"
	$"00000000 00040000 00000020 00200000"
	$"00000C00 00401F00 00407FC0 00407FF0"
	$"00E07FFC F1F07FFF FFF87FFF FFFF7FFF"
	$"FFF87FFF FFF07FFF FFE07FFF FFC07FFF"
	$"FFC07FFF FFC07FFF FFC07FFF FFC07FFF"
	$"FFC07FFF FFC07FFF FFC07FFF FFC07FFF"
	$"FFC07FFF FFC03FFF FFC00FFF FFC003FF"
	$"FFC000FF FFC0003F FFE8000F FFD40003"
	$"FFEA0000 FFD50000 3FEA0000 0FD40000"
	$"03A80C00 00201300 002070C0 00205C30"
	$"0050470C E38E41C3 18504070 0620401C"
	$"0220400C 03204006 01004003 B0804000"
	$"FC404000 07404000 01404000 03404000"
	$"01C04000 03C04000 03C04000 03C04000"
	$"03C06000 03C03800 03C00E00 03C00380"
	$"03C000E0 03C00038 03E8000E 03D40003"
	$"83EA0000 E3D50000 3BEA0000 0FD40000"
	$"03A00000 00000000 00090000 CCCCCCCC"
	$"FFFF0001 99999999 FFFF0002 66666666"
	$"CCCC0003 33333333 66660004 88888888"
	$"88880005 77777777 77770006 44444444"
	$"44440007 FFFF6666 33330008 FFFFFFFF"
	$"0000000F 00000000 00006666 66FFFFFF"
	$"FFFFFFFF FFFF7777 77772222 21F6FFFF"
	$"FFFFFFFF FFFF7777 7777FFF6 1101F6FF"
	$"FFFFFFFF FFFF7777 7777FF12 661101F6"
	$"FFFFFFFF FFF77777 7777FF00 12661101"
	$"F6666FF6 66677877 7777FF00 00126611"
	$"01FF2016 66778887 7777FF00 00001266"
	$"11011117 77788888 7777FF00 00000012"
	$"62111111 11778887 7777FF00 00000000"
	$"26111111 11177877 7777FF00 00000000"
	$"03511111 11117777 7777FF00 00000000"
	$"01266125 11117777 7777FF00 00000000"
	$"00012652 66111777 7777FF00 00000000"
	$"00000000 12321777 7777FF00 00000000"
	$"00000000 00131FFF FFFFFF00 00000000"
	$"00000000 002F4FFF FFFFFF00 00000000"
	$"00000000 001F2FFF FFFFFF00 00000000"
	$"00000000 002F2FFF FFFFFF00 00000000"
	$"00000000 002F2FFF FFFFFF00 00000000"
	$"00000000 002F2FFF FFFFFF00 00000000"
	$"00000000 002F2FFF FFFFFF21 00000000"
	$"00000000 002F2FFF FFFF666F 21000000"
	$"00000000 002F2FFF FFFF6666 6F210000"
	$"00000000 002F2FFF FFFF6666 666F2100"
	$"00000000 002F2FFF FFFF6666 66666F21"
	$"00000000 002F2FFF FFFF6666 6666666F"
	$"21000000 002F2F66 66666666 66666666"
	$"6F210000 002F2FF6 66666666 66666666"
	$"666F2100 002F2FFF 66666666 66666666"
	$"66666F21 002F2FFF F6656666 66666666"
	$"6666666F 212F2FFF 66666666 66666666"
	$"66666666 6F2F2FFF F666FFFF FFFFFFFF"
	$"FFFFFFFF FFFFFFFF 6666"
};
#endif

resource 'DITL'(dialogid_customget,"custard")
{
	{
		{137,278,157,360}, Button{enabled,"Open"},
		{106,278,126,360}, Button{enabled,"Cancel"},
		{-99,-99,-99,-99}, UserItem{enabled},
		{ 10,260, 26,372}, UserItem{enabled}, /* 4 */
		{ 34,278, 54,360}, Button{enabled,"Eject"},
		{ 62,278, 82,360}, Button{enabled,"Desktop"},
		{ 31, 10,177,256}, UserItem{enabled},
		{  8, 10, 27,256}, UserItem{enabled}, /* 8 */
		{ 93,278, 94,361}, Picture{disabled,11},
		{398,273,418,353}, UserItem{disabled},
		{168,278,188,360}, Button{enabled,"Select"},
		{246,117,261,268}, UserItem{enabled}, /* 12 */
		{186, 10,205,210}, Control{enabled,popupmenuid_myfilter},
		{  0,  0,  0,  0}, HelpItem{disabled,HMScanhdlg{-6042}},
		{  0,  0,  0,  0}, HelpItem{disabled,HMScanhdlg{12439}}, /* 15 */
	}
};
resource 'DLOG'(dialogid_customget,"custard")
{
	{100,100,316,480}, movableDBoxProc, invisible, noGoAway,
	'csta', dialogid_customget, "",
	noAutoCenter
};
resource 'dctb'(dialogid_customget)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'DITL'(dialogid_customput,"custer")
{
	{
		{161,264,181,346}, Button{enabled,"Save"},
		{130,264,150,346}, Button{enabled,"Cancel"},
		{-99,-99,-99,-99}, UserItem{enabled},
		{  8,248, 24,350}, UserItem{enabled}, /* 4 */
		{ 32,264, 52,346}, Button{enabled,"Eject"},
		{ 60,264, 80,346}, Button{enabled,"Desktop"},
		{ 29, 10,127,243}, UserItem{enabled},
		{  6, 10, 25,243}, UserItem{enabled}, /* 8 */
		{119,262,120,347}, Picture{disabled,11},
		{156, 13,172,240}, EditText{enabled,""},
		{136, 13,152,225}, StaticText{disabled,"Save as:"},
		{ 88,265,108,345}, UserItem{disabled}, /* 12 */
		{186, 10,205,242}, Control{enabled,popupmenuid_myfilter},
		{  0,  0,  0,  0}, HelpItem{disabled,HMScanhdlg{-6043}},
		{  0,  0,  0,  0}, HelpItem{disabled,HMScanhdlg{12440}}, /* 15 */
	}
};
resource 'DLOG'(dialogid_customput,"custer")
{
	{100,100,316,458}, movableDBoxProc, invisible, noGoAway,
	'cste', dialogid_customput, "",
	noAutoCenter
};
resource 'dctb'(dialogid_customput)
{
	{
		0, 0xEEEE, 0xEEEE, 0xEEEE, /* content - light */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x8888, 0x8888, 0x8888, /* hilite - gray */
	};
};

resource 'CNTL'(popupmenuid_myfilter,"Filter")
{ /* min/max for popupMenu CNTLs are titleWidth/menuID (should be in Controls.r!) */
	{186, 10,205,242}, 0, visible, 40, popupmenuid_myfilter,
	popupMenuCDEFproc, 0, "Type"
};
resource 'MENU'(popupmenuid_myfilter,"Filter")
{
	popupmenuid_myfilter, textMenuProc, allEnabled, enabled, "Filter",
	{
	}
};

/* menus */

#ifndef NO_PROGRAM_MENUS
resource 'MENU'(menuid_apple,"Apple")
{
	menuid_apple, textMenuProc, allEnabled, enabled, apple,
	{
		"About MacFCEU...", plainItem,
		"-", plainItem
	}
};

resource 'MENU'(menuid_file,"File")
{
	menuid_file, textMenuProc, 0xAB7, enabled, "File",
	{
		"Open...", noIcon, "O", noMark, plain, /* was "Load Game..." */
		"Open Recent", noIcon, hierarchicalMenu, submenuchr_recent, plain,
		"Close", noIcon, "W", noMark, plain,
		"-", plainItem,
		"Save State...", noIcon, "S", noMark, plain,
		"Load State...", noIcon, "E", noMark, plain,
		"-", plainItem,
		"Log Sound...", noIcon, "D", noMark, plain,
		"-", plainItem,
		"Save Configuration", plainItem,
		"-", plainItem,
		"Quit", noIcon, "Q", noMark, plain
	}
};

resource 'MENU'(menuid_edit,"Edit")
{
	menuid_edit, textMenuProc, 0x680, enabled, "Edit",
	{
		"Undo", noIcon, "Z", noMark, plain,
		"-", plainItem,
		"Cut", noIcon, "X", noMark, plain,
		"Copy", noIcon, "C", noMark, plain,
		"Paste", noIcon, "V", noMark, plain,
		"Clear", plainItem,
		"-", plainItem,
		"Select All", noIcon, "A", noMark, plain,
		"-", plainItem,
		"Message Log", noIcon, "M", noMark, plain,
		"Memory View", noIcon, "Y", noMark, plain
	}
};

resource 'MENU'(menuid_emulator,"Emulator")
{
	menuid_emulator, textMenuProc, allEnabled, enabled, "Emulator",
	{
		"Reset", noIcon, "R", noMark, plain,
		"Power", noIcon, "P", noMark, plain,
		"-", plainItem,
		"Debug", noIcon, "G", noMark, plain,
		"Step      Ent", plainItem,
	}
};

resource 'MENU'(menuid_special,"Special")
{
	menuid_special, textMenuProc, 0x37BF, enabled, "Special",
	{
		"Sound Quality", noIcon, hierarchicalMenu, submenuchr_sound, plain,
		"Sound Volume", noIcon, hierarchicalMenu, submenuchr_volume, plain,
		"Sound Channels", noIcon, hierarchicalMenu, submenuchr_channels, plain,
		"Expansion Channels", noIcon, hierarchicalMenu, submenuchr_expchannels, plain,
		"Video", noIcon, hierarchicalMenu, submenuchr_video, plain,
		"Speed", noIcon, hierarchicalMenu, submenuchr_speed, plain,
		"-", plainItem,
		"1.6MHz Rate", plainItem,
		"Game PAL", noIcon, "'", noMark, plain,
		"Game Genie", plainItem,
		"Background", noIcon, hierarchicalMenu, submenuchr_background, plain,
		"-", plainItem,
	/*	"Directories...", plainItem,*/
		"Input...", noIcon, "I", noMark, plain,
		"Palette...", noIcon, "T", noMark, plain,
		"Netplay Console...", noIcon, "N", noMark, plain,
	}
};

resource 'MENU'(submenuid_sound,"Sound Quality")
{
	submenuid_sound, textMenuProc, allEnabled, enabled, "Sound",
	{
		"Latency...", plainItem,
		"-", plainItem,
		"8KHz", plainItem,
		"11.025KHz", plainItem,
		"15KHz (Low)", noIcon, "L", noMark, plain,
		"22.05KHz (Default)", noIcon, "K", noMark, plain,
		"36KHz (Moderate)", noIcon, "J", noMark, plain,
		"44.1KHz", plainItem,
		"66.7636KHz", plainItem,
		"88.2KHz", plainItem,
		"96KHz", plainItem,
		"100KHz+ (Best)", noIcon, "H", noMark, plain,
		"Other...", plainItem,
	}
};

resource 'MENU'(submenuid_volume,"Sound Volume")
{
	submenuid_volume, textMenuProc, allEnabled, enabled, "Volume",
	{
		"Off", plainItem,
		"10%", plainItem,
		"20%", plainItem,
		"30%", plainItem,
		"40%", plainItem,
		"50%", plainItem,
		"60%", plainItem,
		"70%", plainItem,
		"80%", plainItem,
		"90%", plainItem,
		"100%", plainItem,
		"110%", plainItem,
		"120%", plainItem,
		"130%", plainItem,
		"140%", plainItem,
		"150%", plainItem,
		"Other...", plainItem
	}
};

resource 'MENU'(submenuid_channels,"Sound Channels")
{
	submenuid_channels, textMenuProc, allEnabled, enabled, "Channels",
	{
		"Rectangle 1", plainItem,
		"Rectangle 2", plainItem,
		"Triangle", plainItem,
		"Noise", plainItem,
		"Delta Modulation", plainItem,
		"-", plainItem,
		"Rect Amp...", plainItem,
		"T/N/D Amp...", plainItem,
		"Triangle Scale...", plainItem,
		"Noise Scale...", plainItem,
		"DC Filter...", plainItem
	}
};

resource 'MENU'(submenuid_expchannels,"Exp Channels")
{
	submenuid_expchannels, textMenuProc, allEnabled, enabled, "Exp Channels",
	{
		"Enable Expansion", plainItem,
		"-", plainItem,
		"Konami VRC VI", plainItem,
		"Konami VRC VII", plainItem,
		"Nintendo FDS", plainItem,
		"Nintendo MMC5", plainItem,
		"Namco 106/163", plainItem,
		"Sunsoft FME-07", plainItem,
		"-", plainItem,
		"VRCVI Volume...", plainItem,
		"VRCVII Volume...", plainItem,
		"FDS Volume...", plainItem,
		"MMC5 Volume...", plainItem,
		"N163 Volume...", plainItem,
		"FME-07 Volume...", plainItem
	}
};

resource 'MENU'(submenuid_video,"Video")
{
	submenuid_video, textMenuProc, allEnabled, enabled, "Video",
	{
		"Fullscreen", noIcon, "F", noMark, plain,
		"Interlacing (x2)", plainItem,
		"Refresh Sync", plainItem, /* Vertical Blank Sync */
		"-", plainItem, /* 7:6 Width (not ready) */
		"Clip Sides", plainItem,
		"No Sprite Limit", plainItem,
		//"Skip Odd Frames", plainItem, /* 2010.04.26 */
		"Auto Skip", plainItem, /* 2013.05.18 */
		"-", plainItem,
		"Tile View         F1", plainItem
	}
};

resource 'MENU'(submenuid_speed,"Speed")
{
	submenuid_speed, textMenuProc, allEnabled, enabled, "Speed",
	{
		"Adjust DMC Rates", plainItem,
		"-", plainItem,
		"50%", plainItem,
		"62.9960525%", plainItem,
		"70.7106781%", plainItem,
		"79.3700526%", plainItem,
		"89.0898718%", plainItem,
		"100%", plainItem,
		"125.992105%", plainItem,
		"158.7401052%", plainItem,
		"178.1797436%", plainItem,
		"200%", plainItem,
		"Other...", plainItem,
	}
};

resource 'MENU'(submenuid_background,"Background")
{
	submenuid_background, textMenuProc, allEnabled, enabled, "Background",
	{
		"Off", plainItem,
		"Full", plainItem,
		"Mute", plainItem,
		"Bkgnd Mute", plainItem,
	}
};
#endif

/* windows */

resource 'WIND'(windowid_screen,"Screen",purgeable)
{
	{100,100,364,356}, noGrowDocProc,
	invisible, goAway, 'scrn',
	"",
	staggerParentWindowScreen
};
resource 'wctb'(windowid_screen)
{
	{
		0, 0, 0, 0, /* content - black */
		1, 0, 0, 0, /* frame - black */
		2, 0, 0, 0, /* text - black */
		3, 0x1111, 0x1111, 0x1111, /* hilite - dark */
	};
};

/* version */

#ifndef NO_ICONS
 #include "fceubundle.r"
#endif

#ifndef NO_STRINGS
 #include "macfceustrs.r"
#endif

#ifndef NO_CONFIG
 #include "inputdialog.r"
 #include "palettedialog.r"
#endif

#ifdef VERSION_STR
resource 'vers'(1)
{
	VERSION_NUM>>24&0xFF,VERSION_NUM>>16&0xFF,VERSION_NUM>>8&0xFF,VERSION_NUM&0xFF,
	verUS,
	VERSION_STR,
	VERSION_STR
#if TARGET_API_MAC_CARBON
	", Mac OS Carbon version"
#else
	", Mac OS Classic version"
#endif
};

resource 'vers'(2)
{
	0x00,0x98,0x20,0x13,
	verUS,
	"0.98.13",
	"Based on FCE Ultra"
};
#endif
