/*
 macos/macgeneral.h (formerly macglue.h)

  Created: 2008.08.12
  Revised: 2013.05.06
*/

#ifndef __MACGENERAL_H
 #pragma once

/* ---- prototypes */

 const void *memrchr(const void *s,
	int c,
	size_t z);

/* copies source to destination, max is maximum length, clipped to 255 */
 unsigned char *cpstrcpy(void *d,
	const void *s,
	unsigned short max);

/* memory remap */
 void memrem(void *p,
	long c,
	const unsigned char *t);

/* memcpy16 exists for performance reasons; 16-byte boundaries (low 4 bits ignored) */
 void memcpy16(void *d,
	const void *s,
	long z);

/* just like GetIndString, but the index is zero-based */
 unsigned char *getpstr(void *d,
	short strlistid,
	int x);
 int getcstr(char *d,
	short strlistid,
	int x);
 int countstrlist(short strlistid);

 #if !ACCESSOR_CALLS_ARE_FUNCTIONS
  #ifdef __CONTROLS__
   UInt16 GetControlHilite(ControlRef control);
   MenuRef GetControlPopupMenuHandle(ControlRef control);
   Rect *GetControlBounds(ControlRef control,
	Rect *bounds);
   void SetControlBounds(ControlRef control,
	const Rect *bounds);
   WindowRef GetControlOwner(ControlRef control);
  #endif

  #ifdef __QUICKDRAW__
   PixMapHandle GetPortPixMap(CGrafPtr port);
   const BitMap *GetPortBitMapForCopyBits(CGrafPtr port);
   Rect *GetPortBounds(CGrafPtr port,
	Rect *bounds);
   Rect *GetRegionBounds(RgnHandle handle,
	Rect *bounds);
   Pattern *GetQDGlobalsGray(Pattern *pattern);
  #endif

  #ifdef __EVENTS__
   void GetGlobalMouse(Point*);
  #endif
 #endif

 #ifdef __MACWINDOWS__
  EXTERN_API(OSStatus) InvalWindowRect(WindowRef window,
	const Rect *bounds);

  int setportwindow(WindowRef w);
  CGrafPtr getvisiblewindowport(WindowRef w);
  Rect *getwindowbounds(WindowRef window,
	Rect *rect);
  Point *localwindowpoint(WindowRef w,
	Point*);
  void updatewindows(RgnHandle updateRgn,
	Boolean paint);
  int invalidatewindow(WindowRef w);
  int drawgrowicon(WindowRef w);
 #endif

 #define __MACGENERAL_H
#endif
