/*
 macos/macinput.h

  Created: 2009.01.20
  Revised: 2013.05.30
*/

#define strlistid_keyscan		160

#if !defined(rez) && !defined(derez)

 typedef ButtConfig	gpbutttype[10];

 typedef struct input_settings
 {
 	boolean		allowudlr;
	uint8		uts[3];
	ButtConfig	ppada[12], ppadb[12];
	ButtConfig	quizking[6];
	ButtConfig	ftrainer[12];
	ButtConfig	hypershot[4];
	ButtConfig	mahjong[21];
	gpbutttype	gamepad1, gamepad2, gamepad3, gamepad4;
	ButtConfig	fkb[0x48];
 } input_settings;

 extern input_settings	inputset;
 #define allowUDLR			inputset.allowudlr
 #define userinputtype			inputset.uts
 #define powerpadsc			(&inputset.ppada)
 #define QuizKingButtons		inputset.quizking
 #define FTrainerButtons		inputset.ftrainer
 #define HyperShotButtons		inputset.hypershot
 #define MahjongButtons			inputset.mahjong
 #define GamePadConfig			(&inputset.gamepad1)
 #define fkbmap				inputset.fkb

 #ifdef TREC_STRUCTS
  static trec	input_trec[] =
  {
	O_TREC(_bool,input_settings,allowudlr),
	C_TREC(input_settings,uts),
	C_TREC(input_settings,ppada),
	C_TREC(input_settings,ppadb),
	C_TREC(input_settings,quizking),
	C_TREC(input_settings,ftrainer),
	C_TREC(input_settings,hypershot),
	C_TREC(input_settings,gamepad1),
	C_TREC(input_settings,gamepad2),
	C_TREC(input_settings,gamepad3),
	C_TREC(input_settings,gamepad4),
	C_TREC(input_settings,fkb),
	{0}
  };
 #endif

/* ---- globals */

extern boolean inputCmdDown;

/* ---- prototypes */

int input_dialog(gpbutttype *gamepad,
	int side); /*0=GamePad 1,2; 1=3,4*/

#endif
