/*
 macos/messagelog.h
  the log window

  Created: 2008.08.02
  Revised: 2013.05.18
*/

#ifndef __MESSAGELOG_H
 #ifdef __MACWINDOWS__
  extern WindowRef logwindow;
 #endif

 /* a log file is always created (or overwritten) when logmessage is first called */
 extern unsigned char	logtofile; /* on by default */

/* pass positive to show, zero to hide, negative to toggle; returns visibility or error */
 int logwindow_show(int show);
 void logwindow_update(boolean erase);
 int logwindow_click(struct EventRecord *event,
 	short what);
 void logwindow_activate(boolean activate);
 void logwindow_scroll(int hcount, int vcount); /* |0x10000 to interpret charcode */

 void logwindow_clear(void);
 int logwindow_scrap(int w);

 int logmessage(const char *str,
 	long length); /* pass negative for length to interpret C-string */

# define __MESSAGELOG_H
#endif
