/*
 mappers/189.c
  Yokosoft / TXC

 * MacFCEU 0.8a5
 *
 * No Copyright notice was present in this FCE Ultra file.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Is this an MMC3 workalike piece of hardware, with the addition of
   a register at $4120 or does it have only partial MMC3 functionality?
   A good test would be to see if commands 6 and 7 can change PRG banks
   and of course test the regs >=$c000, on the real cart.
*/
#include "mapinc.h"

#define cmd mapbyte1[0]

static DECLFW(M189_write)
{
//if(A>=0xc000) printf("$%04x:$%02x\n",A,V);
	if ((A&0xF100)==0x4100)
		{ROM_BANK32(V>>4); return;}
	else if((A&0xF100)==0x6100)
		{ROM_BANK32(V&3); return;}
	switch(A&0xE001)
	{
	case 0xA000: MIRROR_SET(V&1); break;
	case 0x8000: cmd = V; break; 
	case 0x8001: switch(cmd&7)
		{
		case 0: VROM_BANK2(0x0000,V>>1); break;
		case 1: VROM_BANK2(0x0800,V>>1); break;
		case 2: VROM_BANK1(0x1000,V); break;
		case 3: VROM_BANK1(0x1400,V); break;
		case 4: VROM_BANK1(0x1800,V); break;
		case 5: VROM_BANK1(0x1C00,V); break;
		}
	case 0xC000: IRQLatch = V; break;
	case 0xC001: IRQCount = IRQLatch; break;
	case 0xE000: IRQa = 0; X6502_IRQEnd(FCEU_IQEXT); break;
	case 0xE001: IRQa = 1;
	}
}

void m189irq(void)
{
	if (IRQa && IRQCount && !--IRQCount)
		X6502_IRQBegin(FCEU_IQEXT);
}

void Mapper189_init(void)
{
	GameHBIRQHook = m189irq;
	SetWriteHandler(0x4120,0xFFFF,M189_write);
	SetReadHandler(0x6000,0x7FFF,0);
	ROM_BANK32(0);
}
