/*
 mappers/21.c
  VRCIV-2

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  21.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"

#define K4buf mapbyte2
#define K4IRQ mapbyte1[1]
#define K4sel mapbyte1[0]

static uint8	ktype;
static uint16	acount = 0;

static DECLFW(M21_write8)
{
(void)A;
	if (K4sel&2)
		ROM_BANK8(0xC000,V);
	else
		ROM_BANK8(0x8000,V);
}

static DECLFW(M21_write9)
{
	A|= A>>5;
	if ((A&=6)==0)
	{
		if (V&2)
			onemir(V&1);
		else
			MIRROR_SET(V&1);
		return;
        }
	if ((K4sel^V)&2)
	{
		uint8	swa = PRGBankList[0];

		ROM_BANK8(0x8000,PRGBankList[2]);
		ROM_BANK8(0xC000,swa);
	}
	K4sel = V;
}

static DECLFW(M21_writeBCDE)
{
	int	x;

	A|= A>>5&15;
//	A&= 0xF006;
	x = (A>>2&1)|(A-0xB000>>11);

	A&= 2, A+= A;
	K4buf[x]&= 0xF0>>A;
	K4buf[x]|= (V&15)<<A;
	VROM_BANK1(x<<10,K4buf[x]);
}

static DECLFW(M21_writeF)
{
	A|= A>>5, V&= 15;
	if ((A&=6)==0)
		IRQLatch&= 0xF0, IRQLatch|= V;
	else if ((A-=2)==0) //2
		IRQLatch&= 15, IRQLatch|= V<<4;
	else if ((A-=2)==0) //4
	{
		IRQCount = IRQLatch, acount = 0;
		IRQa = V&2;
		K4IRQ = V&1;
		goto irqend;
	} else
	{
		IRQa = K4IRQ;
	irqend:
		X6502_IRQEnd(FCEU_IQEXT);
	}
}

static void FP_FASTAPASS(1) KonamiIRQHook4(int a)
{
#define KLCYCS ((227*2)+1) //I've no reason to think that this's correct...
//#define LCYCS 341
	if (!IRQa || (acount+=a*4)<KLCYCS) //acount+=a*3;
		return;
	do
	{
		acount-= KLCYCS;
		if (++IRQCount>=0x100)
		{
			X6502_IRQBegin(FCEU_IQEXT);
			IRQCount = IRQLatch;
		}
	} while(acount>=KLCYCS);
}

void Mapper21_init(void)
{
        SetWriteHandler(0x8000,0x8FFF,M21_write8);
        SetWriteHandler(0x9000,0x9FFF,M21_write9);
        SetWriteHandler(0xA000,0xAFFF,ROM_BANK8W);
        SetWriteHandler(0xB000,0xEFFF,M21_writeBCDE);
        SetWriteHandler(0xF000,0xFFFF,M21_writeF);
        MapIRQHook = KonamiIRQHook4;
}
