/*
 mappers/255.c
  BMC 110/115-in-1

 * MacFCEU 0.6.4
 *
 * Copyright notice for this file:
 *  255.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"

static DECLFW(M255W8)
{
	uint32		pbank = A>>7&0x1F;
	uint32		cbank = A&0x3F;
	uint32		rbank = A>>14&1;
(void)V;
	if (A&0x1000)
	{
		pbank+= pbank, pbank|= rbank<<6;
		pbank|= A>>6&1;
		ROM_BANK16(0x8000,pbank);
		ROM_BANK16(0xC000,pbank);
	} else
		ROM_BANK32(pbank|(rbank<<5));
	MIRROR_SET(A>>13&1);
	VROM_BANK8((rbank<<6)|cbank);
}

static DECLFW(M255W5)
{
	mapbyte1[A&3] = V&0xF;
}

static DECLFR(M255R5)
{
	return mapbyte1[A&3]; //|(XFrame.DB&0xF0));
}

void Mapper255_init(void)
{
	mapbyte1[0] = mapbyte1[1] = 0xF;
	ROM_BANK32(0);
	VROM_BANK8(0);
	SetWriteHandler(0x5800,0x5FFF,M255W5);
	SetWriteHandler(0x8000,0xFFFF,M255W8);
	SetReadHandler(0x5800,0x5FFF,M255R5);
}
