/*
 mappers/42.c

 * MacFCEU 0.6.4
 *
 * Copyright notice for this file:
 *  42.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"

static DECLFW(M42WE)
{
	if ((A&=3)==0)
	{
		mapbyte1[0] = V;
		ROM_BANK8(0x6000,V&0xF);
	} else if (--A==0) //1
		MIRROR_SET(V>>3&1);
	else if (--A==0) //2
	{
		if ((IRQa=V&2)==0)
			IRQCount = 0;
		X6502_IRQEnd(FCEU_IQEXT);
	}
}

static void FP_FASTAPASS(1) M42IRQ(int a)
{
	if (!IRQa)
		return;
	IRQCount+=a;
	if (IRQCount>= 32768)
		IRQCount-= 32768;
	if (IRQCount>=24576)
		X6502_IRQBegin(FCEU_IQEXT);
	else
		X6502_IRQEnd(FCEU_IQEXT);
}

static void M42Restore(int v)
{
(void)v;
	ROM_BANK8(0x6000,mapbyte1[0]&0xF);
}

void Mapper42_init(void)
{
	ROM_BANK8(0x6000,0);
	ROM_BANK32(~0);
	SetCartRead(0x6000,0x7FFF);
	SetWriteHandler(0x6000,0xDFFF,0);
	SetWriteHandler(0xE000,0xFFFF,M42WE);
	MapStateRestore = M42Restore;
	MapIRQHook = M42IRQ;
}

