/*
 mappers/BMCM20x.c

 * MacFCEU 0.6.6
 *
 * Copyright notice for this file:
 *  200.c, 201.c Copyright (C) 2003 CaH4e3
 *  202.c, 203.c Copyright (C) 2003 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"

/* ---- mapper 200: BMC 1200/36-in-1 */

static DECLFW(M200W8)
{
(void)V;
	MIRROR_SET(A>>3&1);
	ROM_BANK16(0x8000,A&=7);
	ROM_BANK16(0xC000,A);
	VROM_BANK8(A);
}

void Mapper200_init(void)
{
	SetWriteHandler(0x8000,0xFFFF,M200W8);
}

/* ---- mapper 201: BMC 21/8-in-1 */

static DECLFW(M201W8)
{
(void)V;
	if (A&8)
	{
		ROM_BANK32(A&3);
		VROM_BANK8(A&3);
	} else
	{
		ROM_BANK32(0);
		VROM_BANK8(0);
	}
}

void Mapper201_init(void)
{
	ROM_BANK32(0);
	VROM_BANK8(0);
	SetWriteHandler(0x8000,0xFFFF,M201W8);
}

/* ---- mapper 202: BMC 150-in-1 */

static DECLFW(M202W8)
{
	int		tmp = A>>1&7;
(void)V;
	MIRROR_SET(A&1);
	ROM_BANK16(0x8000,tmp);
	ROM_BANK16(0xC000,tmp+!(~tmp&6));
	VROM_BANK8(tmp);
}

void Mapper202_init(void)
{
	ROM_BANK16(0x8000,0);
	ROM_BANK16(0xC000,0);
	VROM_BANK8(0);
	SetWriteHandler(0x8000,0xFFFF,M202W8);
}

/* ---- mapper 203: BMC 35-in-1 */

static DECLFW(M203W8)
{
(void)A;
	VROM_BANK8(V&3);
	ROM_BANK16(0x8000,V=V>>2); //&3);
	ROM_BANK16(0xC000,V);
}

void Mapper203_init(void)
{
	ROM_BANK16(0x8000,0);
	ROM_BANK16(0xC000,0);
	VROM_BANK8(0);
	SetWriteHandler(0x8000,0xFFFF,M203W8);
}
