/*
 mappers/NTDECAsder.c

 * MacFCEU 0.5.5
 *
 * Copyright notice for this file:
 *  112.c Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "mapinc.h"

#define cmd mapbyte1[0]

//previously not present, but would be zero (backward-compatible); 2010.03.20
#define chrsel mapbyte1[1]
#define chrhi mapbyte1[2]

static DECLFW(M112_write8)
{
(void)A;
	cmd = V;
}

static DECLFW(M112_writeA)
{
	int	ext = chrsel&2 ? chrhi:0;
(void)A;
	switch(cmd&7)
	{
	case 0: ROM_BANK8(0x8000,V); break;
	case 1: ROM_BANK8(0xA000,V); break;
	case 2: VROM_BANK2(0x000,(V>>1)|(ext<<5&0x80)); break;
	case 3: VROM_BANK2(0x800,(V>>1)|(ext<<4&0x80)); break;
	case 4: VROM_BANK1(0x1000,V|(ext<<4&0x100)); break;
	case 5: VROM_BANK1(0x1400,V|(ext<<3&0x100)); break;
	case 6: VROM_BANK1(0x1800,V|(ext<<2&0x100)); break;
	case 7: VROM_BANK1(0x1c00,V|(ext<<1&0x100)); break;
	}
}

static DECLFW(M112_writeCDEF)
{
	int	ext;

	if (A&0x2000) //EF
	{
		chrsel = V, V&= 1;
		MIRROR_SET(V);
	} else
		chrhi = V;

	ext = chrsel&2 ? chrhi:0;
	VROM_BANK2(0x000,(CHRBankList[0]>>1&0x7F)|(ext<<5&0x80));
	VROM_BANK2(0x800,(CHRBankList[2]>>1&0x7F)|(ext<<4&0x80));
	VROM_BANK1(0x1000,(CHRBankList[4]&0xFF)|(ext<<4&0x100));
	VROM_BANK1(0x1400,(CHRBankList[5]&0xFF)|(ext<<3&0x100));
	VROM_BANK1(0x1800,(CHRBankList[6]&0xFF)|(ext<<2&0x100));
	VROM_BANK1(0x1C00,(CHRBankList[7]&0xFF)|(ext<<1&0x100));
}

void Mapper112_init(void)
{
	SetWriteHandlerI(2,0x8000,0x9FFE,M112_write8);
	SetWriteHandlerI(2,0xA000,0xBFFE,M112_writeA);
	SetWriteHandlerI(2,0xC000,0xFFFE,M112_writeCDEF);
}
