/*
 memory.h

 * MacFCEU 0.9
 *
 * Copyright notice for this file:
 *  memory.h Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Various macros for faster memory stuff 
    (at least that's the idea) 
*/

/* don't need to unroll inner loop much - large counts aren't usually given */
#define FCEU_dwmemset(d,c,n) do{unsigned long *__d=(unsigned long*)(d); int __x; \
	if((__x=n)<=0) break; \
	if(__x&4) *__d++=c; \
	if(__x&8) *__d++=c,*__d++=c; \
	if(__x&16) *__d++=c,*__d++=c,*__d++=c,*__d++=c; \
	if(__x&=-32) do{ \
		*__d++=c,*__d++=c,*__d++=c,*__d++=c,*__d++=c,*__d++=c,*__d++=c,*__d++=c; \
	}while(__x+=-32); \
}while(0)

void *FCEU_malloc(unsigned long size);
void *FCEU_gmalloc(unsigned long size);
/* got rid of FCEU_gfree -- it calls for and does the same thing FCEU_free does */
void FCEU_free(void *ptr);

void FCEU_memcpy(void *d,
	const void *s, /* must be valid */
	unsigned long l); /* was incorrectly FCEU_memmove (does not handle reverse cpy) */
void dwmemset(void *p, /* must be valid */
	long c,
	unsigned long z); /* was FCEU_memsetl */

void _memrem4(void *p, /* must be valid */
	uint32 c, /* must be >1 */
	const uint8 *t); /* must be valid */
