/*
 netplay.h

 * MacFCEU 0.6.2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* ---- constants */

#define FCEUNPCMD_RESET		0x01
#define FCEUNPCMD_POWER 	0x02

#define FCEUNPCMD_VSUNICOIN	0x07
#define FCEUNPCMD_VSUNIDIP0	0x08
#define FCEUNPCMD_FDSINSERTx	0x10
#define FCEUNPCMD_FDSINSERT	0x18
#define FCEUNPCMD_FDSEJECT	0x19	/* obsolete */
#define FCEUNPCMD_FDSSELECT	0x1A

/* these pseudo-commands load extra data after the timestamp */
#define FCEUNP_KEYTYPE		0x1C	/* such as FKB */
#define FCEUNP_CURSORTYPE	0x1D	/* such as Zapper */
/* bit #1 = 32 bits of data, otherwise 16 bits */

#define FCEUNPCMD_LOADSTATE	0x80

#define FCEUNPCMD_SAVESTATE	0x81 /* Sent from server to client. */
#define FCEUNPCMD_LOADCHEATS	0x82
#define FCEUNPCMD_TEXT		0x90

/* ---- externs */

extern int FCEUnetplay;

/* ---- prototypes */

int InitNetplay(void);
void NetplayUpdate(uint8 *joyp);

int FCEUNET_SendCommand(uint8,
	uint32);
int FCEUNET_SendFile(uint8 cmd,
	char*);
