/*
 state.h

 * MacFCEU 0.6.6
 *
 * Copyright notice for this file:
 *  state.h Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

void FCEUSS_Save(const char*);
int FCEUSS_Load(const char*);

int FCEUSS_SaveFP(struct FILE*,
	int movie);
int FCEUSS_LoadFP(struct FILE*);

extern int CurrentState;

void FCEUSS_CheckStates(void);

typedef struct SFORMAT/*(16+)*/
{
	void		*v;
	uint32		s;
	char		desc[4]; //was ptr, 8 bytes; 2010.03.14
} SFORMAT;

void ResetExState(void (*PreSave)(void),
	void (*PostSave)(void));

void AddExState(
	void *v, //either raw ptr or SFORMAT (pass ~0 for s)
	uint32 s,
	int type,
	const char *desc);

#define FCEUSTATE_RLSB            0x80000000

void FCEU_DrawSaveStates(uint8 *XBuf);
