/*
 types.h

 * MacFCEU 0.8a5
 *
 * Copyright notice for this file:
 *  types.h Copyright (C) 2001 Aaron Oneal
 *  types.h Copyright (C) 2002 Xodnizel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __FCEU_TYPES

 #include "enviro64.h"

 /* added here; 2010.04.01 */
 #ifndef false
  #define false 0
 #endif
 #ifndef true
  #define true 1
 #endif

#ifdef __GNUC__
 #define INLINE inline
 #define GINLINE inline
#elif MSVC
 #define INLINE __inline
 #define GINLINE		/* Can't declare a function INLINE
				   and global in MSVC.  Bummer.
				*/
 #define PSS_STYLE 2		/* Does MSVC compile for anything
				   other than Windows/DOS targets?
				*/
#endif

#if PSS_STYLE==2
 #define PSS "\\"
 #define PS '\\'
#elif PSS_STYLE==1
 #define PSS "/"
 #define PS '/'
#elif PSS_STYLE==3
 #define PSS "\\"
 #define PS '\\'
#elif PSS_STYLE==4
 #define PSS ":" 
 #define PS ':'
#endif

#define FP_FASTAPASS(x)
#define FASTAPASS(x)
#if defined(__GNUC__) && defined(C80x86)
 #undef FP_FASTAPASS
 #undef FASTAPASS
 #define FP_FASTAPASS(x)	__attribute__((regparm(x)))
 #define FASTAPASS(x)		__attribute__((regparm(x)))
#elif MSVC
 #undef FASTAPASS
 #define FASTAPASS(x)		__fastcall
#endif

 /* JMP bypass simplified here - UnloadSeg'll never be called; 2013.05.05 */
#if env68k
 #define OptFAddr(f,s) do{if(*(uint16*)(f=s)==0x4EF9) f=*(void**)(2+(char*)(f));}while(0)
#else
 #define OptFAddr(f,s) (void)(f=s)
#endif

typedef void (FP_FASTAPASS(2) *writefunc)(uint32 A, uint8 V);
typedef uint8 (FP_FASTAPASS(1) *readfunc)(uint32 A);

 #define __FCEU_TYPES
#endif
