/*
 eval_op.h
*/

/* ---- constants */

enum
{/* operator types */
 /* unary - all-type */
	_op_ldv,	/* (load) */
	_op_ldi,	/* @	(load indirect) */
	_op_srt,	/* ~/	[or]	CHR_RA */
	_op_abs,	/* + */
/*0x04*/_op_neg,	/* -	[or]	CHR_MN */
	_op_not,	/* ~	(compliment) */
	_op_bno,	/* !	(boolean not - no fp) */
	_op_dno,	/* double-not (optimized !!b) */
#ifdef ALLOW_BIN_HI_LO
	_op_blo,	/* <	(binary low byte) */
	_op_bhi,	/* >	(binary high byte) */
#endif
 /* dyadic logic/shift - no-fp */
/*0x08*/_op_bor,	/* || */
	_op_ban,	/* && */
	_op_ior,	/* | */
	_op_and,	/* & */
/*0x0C*/_op_eor,	/* ^ */
	_op_asr,	/* >>> */
	_op_shr,	/* >> */
	_op_shl,	/* << */
 /* dyadic math - all-type */
/*0x10*/_op_add,	/* + */
	_op_sub,	/* - */
	_op_mul,	/* * */
	_op_pow,	/* ** */
/*0x14*/_op_div,	/* / */
	_op_dvs,	/* //	[or]	CHR_DV */
	_op_mod,	/* % */
	_op_mds,	/* %% */
 /* dyadic compare - all-type */
/*0x18*/_op_clt,	/* <	(less than) */
	_op_cge,	/* >=	(greater or equal) */
	_op_cgt,	/* >	(greater than) */
	_op_cle,	/* <=	(less or equal) */
/*0x1C*/_op_cne,	/* !=	[or]	CHR_NE */
	_op_ceq,	/* = */
	_op_cni,	/* <>	(not identical) */
	_op_cid,	/* ==	(identical) */

/*0x20*/_op_ret,	/* return - counts as a terminator on the parsing stack */
	_op_cst,	/* t	(cast:type) */
	_op_phs,	/* (	(push stack) */
	_op_phl,	/* ,	(push list) */

	_op_cml,	/* n(p)	(call) */
	_op_bra,	/* :	(branch)  [also]   :>	[label] */
	_op_brz,	/* ?	(branch on zero) */
	_op_bnz,	/* <?	(branch non-zero) */

	_op_apn,	/* .=>	(append) */
	_op_stv,	/* ==>	(store) */
	/* the dyadics are repeated in a 'set' context (e.g., `+=>` for 'add to') */
/* first to last unary -- must update if changed */
	_oc_una		= _op_ldv,
	_oc_unb		= _op_bor-1,
/* operation index mask (6 bits) */
	_oc_msk		= 0x3F,
	_oc_obj		= 0xFFFF	/* value (instead of a symbol) in parsing */
};
