/*
 video.h

 * MacFCEU 0.9d3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define FCEUSCRN_ROWSIZE	512 /* no longer 256 necessarily */

/*
 bits:
  #7 background priority
  #6 sprite priority
*/
#define PLB_B			0x80
#define PLB_S			0x40

#define PAL_WHITE		0
#define PAL_LTGRAY		1
#define PAL_RED			2
#define PAL_DRED		3
#define PAL_YELLOW		4
#define PAL_CYAN		5
#define PAL_BGRAY		6
#define PAL_VIOLET		7
#define PAL_BLACK		255

/* ---- globals */

extern uint8	*XBuf;
extern uint8	FCEUvideoShot; /* only use FCEUI_SaveSnapshot for snaps */

extern uint8	epal_inv[2048];

/* ---- prototypes */

int FCEU_InitVirtualVideo(void);
void FCEU_KillVirtualVideo(void);

int SaveSnapshot(void);
void FCEU_ResetSnaps(void);

void FCEU_DrawNumberRow(uint8 *XBuf,
	uint8 *nstatus,
	int cur);

void FCEU_ResetMessages(int on);

void FCEU_PutImage(uint32 framecnt,
	uint8 skip);
