/*
 miniunz.r

  Created: 2014.04.02
  Revised: 2014.04.06
*/

#include "Dialogs.r"
#include "Finder.r"
#include "MacTypes.r"
#include "Processes.r"

#ifndef NO_SIZE
 #define applicationProcessFlags \
  reserved, ignoreSuspendResumeEvents, reserved, canBackground, \
  notMultiFinderAware, backgroundAndForeground, dontGetFrontClicks, ignoreChildDiedEvents, \
  is32BitCompatible, isHighLevelEventAware, onlyLocalHLEvents, notStationeryAware, \
  dontUseTextEditServices, notDisplayManagerAware, reserved, reserved
#endif

#ifdef applicationProcessFlags
resource 'SIZE'(-1)
{
	applicationProcessFlags,
	384<<10, 256<<10 /* Finder suggested size, bare minimum size (tested) */
};
#endif

resource 'DITL'(322)
{
	{
		{161,264,181,346},Button{enabled,"Save"},
		{130,264,150,346},Button{enabled,"Cancel"},
		{-99,-99,-99,-99},UserItem{enabled},
		{  8,248, 24,350},UserItem{enabled}, /* 4 */
		{ 32,264, 52,346},Button{enabled,"Eject"},
		{ 60,264, 80,346},Button{enabled,"Desktop"},
		{ 29, 10,159,243},UserItem{enabled},
		{  6, 10, 25,243},UserItem{enabled}, /* 8 */
		{119,262,120,347},Picture{disabled,11},
		{196, 30,212,346},StaticText{disabled," "}, /* hack */
		{162, 20,194,240},StaticText{disabled,"Select destination"},
		{ 88,265,108,345},UserItem{disabled}, /* 12 */
		{  0,  0,  0,  0},HelpItem{disabled,HMScanhdlg{-6043}},
		{  0,  0,  0,  0},HelpItem{disabled,HMScanhdlg{12440}}
	}
};

resource 'DLOG'(322,"Directory")
{
	{100,100,316,458}, dBoxProc, invisible, noGoAway, 'cdir', 322,
	"",
	noAutoCenter
};

data 'DITL'(999)
{
	$"00020000000000310086004700D20404"
	$"53746F70000000000008000800280028"
	$"A002000000000000000A0030002600F8"
	$"881B44657374696E6174696F6E20766F"
	$"6C756D652069732066756C6C2170"
};

data 'ALRT'(999,"Full")
	{$"002800280078012603E75554300A"};

resource 'ALRT'(1000,"Overwrite?")
{
	{ 40, 40,140,412}, 1000,
	{
		OK, invisible, silent,
		OK, invisible, silent,
		OK, invisible, silent,
		OK, visible, sound1
	},
	alertPositionMainScreen
};

resource 'DITL'(1000)
{
	{
		{ 66,274, 88,348},Button{enabled,"No"},
		{ 66,174, 88,250},Button{enabled,"Yes"},
		{ 66, 50, 88,160},Button{enabled,"Overwrite All"},
		{  8, 48, 56,364},StaticText{disabled,"Overwrite ^0?"},
		{  8,  8, 40, 40},Icon{disabled,2}
	}
};

resource 'DITL'(1001)
{
	{
		{103,280,125,360},Button{enabled,"Extract"},
		{103,184,125,256},Button{enabled,"List"},
		{103, 92,125,170},Button{enabled,"Cancel"},
		{ 50,142, 66,390},EditText{enabled,""}, /*4*/
		{ 24, 12, 40,390},EditText{enabled,""},
		{ 74, 64, 92,174},CheckBox{enabled,"Ignore Paths"},
		{ 72,188, 92,328},CheckBox{enabled,"Ignore '.DS_Store'"},
		{ 50,  4, 66,139},StaticText{disabled,"Password (optional)"}, /*8*/
		{  4,  4, 20,132},StaticText{disabled,"One file (optional)"}
	}
};

resource 'DITL'(1002)
{
	{
		{  6,  6, 22,400},StaticText{disabled,"Processing..."},
		{ 22,  4, 70,456},StaticText{disabled,"123\n*Pelham, 123!*"}
	}
};

resource 'DLOG'(1001,"Options")
{
	{ 68, 46,204,446}, movableDBoxProc, invisible, noGoAway, 0, 1001,
	"Options",
	centerMainScreen
};

resource 'DLOG'(1002, "Progress")
{
	{ 64, 20,138,480}, movableDBoxProc, invisible, noGoAway, 0, 1002,
	"Progress",
	staggerMainScreen
};

data 'dctb'(1002)
{
	$"00000000000000040000EEEEEEEEEEEE"
	$"00010000000000000002000000000000"
	$"00030000000000000004FFFFFFFFFFFF"
};

resource 'open'(0)
{
	'mUnz',
	{ /* 0 does not work with the Finder; the SF types are not enough */
		'****'
	}
};

resource 'vers'(1)
{
	1,0x01,development,6,
	verUS,
	"1.01e+",
	"1.01e+ (C) 1998-05 Gilles Vollant; Mac OS app (14.04.06) by Adam P."
};

resource 'vers'(2)
{
	1,0x23,development,7,
	verUS,
	"1.23gz2",
	"1.23gz2 (C) 1995-05 ZLib developers"
};
